/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main;

import java.util.Iterator;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.algorithms.Algorithm;
import messif.operations.AnswerType;
import messif.operations.query.GetAllObjectsQueryOperation;
import sf.algorithm.SketchAlgorithmWithRefinement;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class SketchCardinalitiesCounter {

    @SuppressWarnings("FinalizeCalledExplicitly")
    public static void main(String[] args) {
        try {
            SketchAlgorithmWithRefinement alg = (SketchAlgorithmWithRefinement) Algorithm.restoreFromFile(args[0]);
            GetAllObjectsQueryOperation allSketches = alg.getAllSketches(new GetAllObjectsQueryOperation(AnswerType.ORIGINAL_OBJECTS));
            Iterator it = allSketches.getAnswer();
            evaluate(it);
            alg.finalize();
            System.exit(0);
        } catch (Throwable ex) {
            Logger.getLogger(SketchCardinalitiesCounter.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static SortedMap<Integer, Integer> evaluate(Iterator<Sketch> it) {
        SortedMap<Integer, Integer> ret = new TreeMap<>();
        while (it.hasNext()) {
            Sketch sketch = it.next();
            Integer cardinality = sketch.getCardinality();
            if (ret.containsKey(cardinality)) {
                Integer value = ret.get(cardinality);
                ret.put(cardinality, value + 1);
            } else {
                ret.put(cardinality, 1);
            }
        }
//        for (int i = 0; !counts.isEmpty(); i++) {
//            if (counts.containsKey(i)) {
//                counts.remove(i);
//            }
//        }
        return ret;
    }
}
