/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.algorithms.AlgorithmMethodException;
import messif.algorithms.impl.ParallelSequentialScan;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorL2;
import messif.objects.util.AbstractObjectList;
import messif.objects.util.RankedAbstractObject;
import messif.operations.data.BulkInsertOperation;
import messif.operations.query.KNNQueryOperation;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.objects.sketchcreator.impl.GenHyperplane;

/**
 *
 * @author xmic
 */
public class AverageHamDistToKNN {

    public static void main(String[] args) {
        int sketchSize = 256;
//        String sketches = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\90_10\\sketches\\sketches-28210.data";
        String sketches = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\Decaf20M\\50_50_" + sketchSize + "b.data";

        String pivots = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
//        String pivotsCsv = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\90_10\\pivots\\UncorrelatedPivots_" + sketchSize + "_pairs.csv";
        String pivotsCsv = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\UncorrelatedPivots_" + sketchSize + "_pairs.data";
        String queries = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
        String clazz = ObjectFloatVectorL2.class.getName();
        int[] ks = new int[]{1};
        try {
            float[] avgDist = evaluateAverageSketchDistanceToKNN(ks, sketches, sketchSize, pivots, pivotsCsv, queries, clazz);
            for (int i = 0; i < avgDist.length; i++) {
                int k = ks[i];
                float avg = avgDist[i];
                System.out.println("Sketches length: " + sketchSize + ", average distance to " + k + "NN neighbour: " + avg);
            }
        } catch (AlgorithmMethodException | NoSuchMethodException ex) {
            Logger.getLogger(AverageHamDistToKNN.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    @SuppressWarnings("FinalizeCalledExplicitly")
    private static float[] evaluateAverageSketchDistanceToKNN(int[] ks, String sketchesFile, int sketchSize, String pivotsFile, String pivotsCsv, String queries, String clazz) throws AlgorithmMethodException, NoSuchMethodException {
        ObjectToSketchTransformator trans = new GenHyperplane(pivotsFile, clazz, sketchSize, pivotsCsv, false);
        float[] retSum = new float[ks.length];
        int count = 0;
        Iterator<Sketch> sketches = Tools.getIterator(Sketch.class.getName(), sketchesFile);
        ParallelSequentialScan alg = createAlg(sketches);
        Iterator<LocalAbstractObject> itQueries = Tools.getIterator(clazz, queries);
        while (itQueries.hasNext()) {
            LocalAbstractObject query = itQueries.next();
            Sketch querySketch = trans.transform(query);
            KNNQueryOperation knn = new KNNQueryOperation(querySketch, ks[ks.length - 1]);
            knn = alg.executeOperation(knn);
            List<RankedAbstractObject> answer = new AbstractObjectList(knn.getAnswer());
            for (int i = 0; i < ks.length; i++) {
                int k = ks[i];
                RankedAbstractObject rao = answer.get(k - 1);
                float dist = rao.getDistance();
                retSum[i] += dist;
            }
            count++;
        }
        try {
            alg.finalize();
        } catch (Throwable ex) {
            Logger.getLogger(AverageHamDistToKNN.class.getName()).log(Level.SEVERE, null, ex);
        }
        for (int i = 0; i < retSum.length; i++) {
            retSum[i] = retSum[i] / count;
        }
        return retSum;
    }

    private static ParallelSequentialScan createAlg(Iterator<Sketch> sketches) {
        try {
            ParallelSequentialScan ret = new ParallelSequentialScan(8);
            BulkInsertOperation insert = new BulkInsertOperation(sketches);
            ret.executeOperation(insert);
            return ret;
        } catch (AlgorithmMethodException | NoSuchMethodException ex) {
            Logger.getLogger(AverageHamDistToKNN.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
}
