/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Map;
import java.util.Random;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class CheckTightnessOfCardLowerBound {

    public static void main(String[] args) throws FileNotFoundException {
//        int[] sizes = new int[]{32, 64, 128, 205, 256};
        String[] sizes = new String[]{"064", "128", "192"};
        int[] divisions = new int[]{0, 1, 2, 4, 8, 16};
        for (String size : sizes) {
            String[] skPaths = new String[]{
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\80_20_" + size + "b.data.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data_1.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\80_20_" + size + "b.data_1.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data_2.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\80_20_" + size + "b.data_2.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data_4.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\80_20_" + size + "b.data_4.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data_8.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\80_20_" + size + "b.data_8.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data_16.gz",
                "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\80_20_" + size + "b.data_16.gz",};
            String output = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\Lower_bounds_" + size + "b.csv";
            System.setErr(new PrintStream(output));

            for (int i = 0; i < skPaths.length; i++) {
                System.err.println("\nFile path: " + skPaths[i]);
                Map<String, LocalAbstractObject> sketches = Tools.getObjectsAsLocatorMap(Sketch.class.getName(), skPaths[i], -1);
                CheckTightnessOfCardLowerBound evaluator = new CheckTightnessOfCardLowerBound(sketches, Integer.parseInt(size), divisions);
                evaluator.evaluate(50000);
                System.err.flush();
            }
        }
    }

    private final Map<String, LocalAbstractObject> sketches;
    private final int sketchLength;
    private final int[] divisions;

    public CheckTightnessOfCardLowerBound(Map<String, LocalAbstractObject> sketches, int sketchLength, int[] divisions) {
        this.sketches = sketches;
        this.sketchLength = sketchLength;
        this.divisions = divisions;
    }

    public void evaluate(int numberOfPairs) {
        Random r = new Random();
        Object[] a = sketches.values().toArray();
        System.err.print("Real dist;Lower bound by cards;");
        for (int k = 2; k < divisions.length; k++) {
            System.err.print("Splitted to " + divisions[k] + ";");
        }
        System.err.println();
        for (int i = 0; i < numberOfPairs; i++) {
            Float[] distsDiff = new Float[divisions.length];
            LocalAbstractObject s1 = getRandomObject(a, r);
            LocalAbstractObject s2 = getRandomObject(a, r);
                s1 = sketches.get(s1.getLocatorURI());
                s2 = sketches.get(s2.getLocatorURI());
                for (int k = 0; k < divisions.length; k++) {
                    int division = divisions[k];
                    float lowerBoundDistance = getLowerBoundDistance(s1, s2, division);
                    if (k == 0) {
                        distsDiff[k] = lowerBoundDistance;
                    } else {
                        distsDiff[k] = distsDiff[0] - lowerBoundDistance;
                    }
                }
                Tools.printCollection(Arrays.asList(distsDiff));
            System.err.println();
        }
    }

    private float getLowerBoundDistance(LocalAbstractObject o1, LocalAbstractObject o2, int d) {
        if (d == 0) {
            return o1.getDistance(o2);
        }
        Sketch s1 = (Sketch) o1;
        Sketch s2 = (Sketch) o2;
        if (d == 1) {
            return Math.abs(s1.getCardinality() - s2.getCardinality());
        }
        int[] s1Cards = s1.getCardinalitiesInBlocks(d, sketchLength);
        int[] s2Cards = s2.getCardinalitiesInBlocks(d, sketchLength);
        int ret = 0;
        for (int i = 0; i < d; i++) {
            ret += Math.abs(s1Cards[i] - s2Cards[i]);
        }
        return ret;
    }

    private LocalAbstractObject getRandomObject(Object[] sketches, Random r) {
        int v = r.nextInt(sketches.length);
        return (LocalAbstractObject) sketches[v];
    }
}
