/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorNeuralNetworkL2;
import messif.objects.util.StreamGenericAbstractObjectIterator;

/**
 *
 * @author xmic
 */
public class DistanceDistributionToGivenObject {

    public static final String className = ObjectFloatVectorNeuralNetworkL2.class.getName();
    public static final String queriesFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
    public static final String sampleFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
    public static final String locatorOfObject = "0000702763";
    public static final Integer NUMBER_OF_OBJECT = 1000000;
    public static final Float DIST_INTERVAL = 2f;

    public static void main(String[] args) {
        LocalAbstractObject query = findQuery(className, queriesFile, locatorOfObject);
        Map<Float, Integer> ret = new TreeMap<>();
        StreamGenericAbstractObjectIterator dataIt = Tools.getIterator(className, sampleFile);
        for (int i = 0; i < NUMBER_OF_OBJECT; i++) {
            if (dataIt.hasNext()) {
                LocalAbstractObject obj = dataIt.next();
                float dist = query.getDistance(obj);
                Float key = (int) (dist / DIST_INTERVAL) * DIST_INTERVAL;
                if (!ret.containsKey(key)) {
                    ret.put(key, 0);
                }
                Integer val = ret.get(key);
                ret.put(key, val + 1);
                if (i % 50000 == 0) {
                    Logger.getLogger(DistanceDistributionToGivenObject.class.getName()).log(Level.INFO, "Processed {0} objects.", i);
                }
            }
        }
        Tools.printMap(ret);
    }

    private static LocalAbstractObject findQuery(String className, String queriesFile, String locatorOfObject) {
        Iterator<LocalAbstractObject> it = Tools.getIterator(className, queriesFile);
        while (it.hasNext()) {
            LocalAbstractObject nextObj = it.next();
            String locatorURI = nextObj.getLocatorURI();
            if (locatorURI.equals(locatorOfObject)) {
                return nextObj;
            }
        }
        return null;
    }

}
