/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author xmic
 */
public class FilterGroundTruthAndResultsOnlySpecificQueries {

    public static void main(String[] args) throws FileNotFoundException {
        String groundTruthPath = "c:\\Data\\2017\\Secondary_filtering\\ground_truth_filtered\\groundtruth-1M-q1000.txt";
        File resultsFolder = new File("c:\\Data\\2017\\Secondary_filtering\\results_filtered\\28560\\");
//        File resultsFolder = new File("c:\\Data\\2017\\Secondary_filtering\\results_filtered\\28045\\");
        File[] listFiles = resultsFolder.listFiles();
        int k = 10;
        float lowerBound = 45;
        float upperBound = 47;
        File orig = new File(groundTruthPath);
        File newFile = getNewFile(lowerBound, upperBound, k, orig);
        System.setOut(new PrintStream(newFile));
        KNNResultFileParser groundTruth = new KNNResultFileParser(groundTruthPath);
        List<KNNResultFileParser.EvaluatedQuery> evaluatedQueries = groundTruth.getEvaluatedQueries();
        int counter = 0;
        for (KNNResultFileParser.EvaluatedQuery evaluatedQuery : evaluatedQueries) {
            Float dist = evaluatedQuery.getDistances().get(k);
            if (lowerBound <= dist && dist <= upperBound) {
                counter++;
                evaluatedQuery.print("query=", System.out);
                addResultsForQuery(lowerBound, upperBound, k, listFiles, evaluatedQuery.getLocatorURI());
            }
        }
        String newName = newFile.getAbsolutePath().replace("q1000", "q" + counter);
        newFile.renameTo(new File(newName));
        System.out.flush();
        System.out.close();
    }

    private static File getNewFile(float lowerBound, float upperBound, int k, File orig) {
        return new File(orig.getParent(), "Filtered_" + k + "NN_from" + lowerBound + "to" + upperBound + orig.getName());
    }

    private static final Map<String, KNNResultFileParser> cache = new HashMap<>();

    private static void addResultsForQuery(float lowerBound, float upperBound, int k, File[] listFiles, String locatorURI) throws FileNotFoundException {
        for (File fileResults : listFiles) {
            if(fileResults.isDirectory()){
                continue;
            }
            File newFile = getNewFile(lowerBound, upperBound, k, fileResults);
            System.setErr(new PrintStream(new FileOutputStream(newFile, true)));
            String absolutePath = fileResults.getAbsolutePath();
            if (!cache.containsKey(absolutePath)) {
                KNNResultFileParser result = new KNNResultFileParser(absolutePath);
                cache.put(absolutePath, result);
            }
            KNNResultFileParser result = cache.get(absolutePath);
            List<KNNResultFileParser.EvaluatedQuery> evaluatedQueries = result.getEvaluatedQueries();
            int idx = evaluatedQueries.indexOf(new KNNResultFileParser.EvaluatedQuery(null, null, locatorURI, null, null, null));
            KNNResultFileParser.EvaluatedQuery evaluatedQuery = evaluatedQueries.get(idx);
            evaluatedQuery.print(null, System.err);
            System.err.flush();
        }
    }

}
