/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.algorithms.Algorithm;
import messif.algorithms.AlgorithmMethodException;
import messif.algorithms.impl.ParallelSequentialScan;
import messif.objects.LocalAbstractObject;
import messif.objects.util.StreamGenericAbstractObjectIterator;
import messif.operations.data.BulkInsertOperation;
import messif.operations.query.KNNQueryOperation;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class GroundTruthMaker {

    @SuppressWarnings("FinalizeCalledExplicitly")
    public static void main(String[] args) throws AlgorithmMethodException, NoSuchMethodException, FileNotFoundException {
        String dataFolder = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Sketches\\";
        String queriesFolder = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Queries_sketches\\";

        File[] dataFiles = new File(dataFolder).listFiles((File dir, String name) -> name.endsWith(".data"));
        int k = 5000;
        String className = Sketch.class.getName();

        for (File dataFile : dataFiles) {
            System.setOut(new PrintStream("c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\.csv"));

        }

//        String data = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\profimedia-1M.data.gz";
//        String queries = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\queryset-sqfd-1000.data";
//        System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\SQFD\\ground-truth-1M_SQFD_part2.txt"));
//        String className = ObjectSignatureSQFD.class.getName();
    }

    private static void evaluate(String data, String queries, String className, int k) throws AlgorithmMethodException, NoSuchMethodException {
        Algorithm alg = new ParallelSequentialScan(5);
        BulkInsertOperation insert = new BulkInsertOperation(Tools.getIterator(className, data), -1);
        alg.executeOperation(insert);

        StreamGenericAbstractObjectIterator queriesIt = Tools.getIterator(className, queries);

//        boolean create = false;
        for (int i = 0; queriesIt.hasNext(); i++) {
            LocalAbstractObject query = queriesIt.next();
//            if(query.getLocatorURI().equals("50063161")){
//                create = true;
//            }
//            if(!create){
//                continue;
//            }
            KNNQueryOperation knn = new KNNQueryOperation(query, k);

            knn = alg.executeOperation(knn);
            Tools.printAnswer(knn, System.out, false, true);
        }
        try {
            alg.finalize();
        } catch (Throwable ex) {
            Logger.getLogger(GroundTruthMaker.class.getName()).log(Level.SEVERE, null, ex);
        }

    }
}
