/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.BitSet;
import messif.objects.util.AbstractObjectList;
import messif.objects.util.StreamGenericAbstractObjectIterator;
import sf.algorithm.myHWT.OrientAndShuffleBitsForHWT;
import sf.algorithm.myHWT.OrientAndShuffleBitsForHWTDynamicLength;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class OrientAndPermuteBitOfSketchesPerPartes {

    public static void main(String[] args) throws FileNotFoundException {
//        String folderPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\"
        String folderPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\Decaf20M\\";
//        String folderPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_100M\\";
//        String folderPath = args[0];
//        int sketchLength = Integer.parseInt(args[1]);
//        int numberOfBlocks = Integer.parseInt(args[2]);

        int[] sketchLengths = new int[]{64, 128, 192, 256};
        for (int sketchLength : sketchLengths) {

//            int[] numbersOfBlocks = new int[]{1, 2, 4, 8};
//            for (int numberOfBlocks : numbersOfBlocks) {
            File folder = new File(folderPath);
            File[] listFiles = folder.listFiles((File dir, String name) -> name.contains(sketchLength + "b.data.gz"));
            for (File sketchesFile : listFiles) {
                String outputPath = sketchesFile.getAbsolutePath();
                outputPath = outputPath.replace(".gz", "");
//            String outputPath = null;
                orientSketches(sketchesFile.getAbsolutePath(), outputPath, sketchLength);
            }
//            }
        }
    }

    public static void orientSketches(String sketchesPath, String outputPath, int sketchLength) throws FileNotFoundException {
        StreamGenericAbstractObjectIterator<Sketch> it = Tools.getIterator(Sketch.class, sketchesPath);
//        List<Integer> indexesToSwitch = getIndexesToSwitchByNumberOfOnes(it, 10000);
        OrientAndShuffleBitsForHWTDynamicLength o = new OrientAndShuffleBitsForHWTDynamicLength(new AbstractObjectList<>(it, 1000000), sketchLength);
        BitSet indexesToSwitch = o.evaluateIndexesOfBitsToSwitch();
        System.setOut(new PrintStream(outputPath + "_block sizes.txt"));
        System.out.println("Sizes of blocks:");
        Tools.printArray(o.getClusterSizes(), ", ");
//        BitSet indexesToSwitch = new BitSet();
//        for (Integer idx : indexesToSwitchSet) {
//            indexesToSwitch.set(idx);
//        }

//        Set<Integer> indexesToSwitch = o.evaluateIndexesOfBitsToSwitchOld();
        int[] permutation = o.getOldBitsPermutation();
        Tools.orientSketches(sketchesPath, outputPath, indexesToSwitch, permutation);
        File skFile = new File(sketchesPath);
        if (!skFile.getAbsolutePath().toLowerCase().contains("queries")) {
            File queriesFolder = new File(skFile.getParentFile(), "Queries");
            String queriesFileName = new File(queriesFolder, skFile.getName().replaceAll(".gz", "")).getAbsolutePath();
//            String queriesFileName = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\SIFT10M\\Queries\\50_50_192b.data";
//            String queriesOutput = new File(queriesFolder, skFile.getName() + "_" + numberOfBlocks).getAbsolutePath();
            String queriesOutput = new File(queriesFolder, skFile.getName()).getAbsolutePath();
            queriesOutput = queriesOutput.replace(".gz", "");
            Tools.orientSketches(queriesFileName, queriesOutput, indexesToSwitch, permutation);
        }
    }

}
