/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.util.AbstractObjectList;
import messif.objects.util.StreamGenericAbstractObjectIterator;
import sf.algorithm.myHWT.OrientBitsForHWTGlobalSum;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class OrientBitOfSketchesViaSumOfCorrMatrix {

    public static void main(String[] args) throws FileNotFoundException {
//        System.setErr(new PrintStream("c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\80_20\\sketches\\indexes.err"));
        String folderPath = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\";
//        String folderPath = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\90_10\\sketches\\";
        File folder = new File(folderPath);
        File[] listFiles = folder.listFiles((File dir, String name) -> name.endsWith("b.data") && !name.startsWith("Uncorrelated") && !name.startsWith("queries"));
        for (File sketchesFile : listFiles) {
            String outputPath = folderPath + "oriented_for_HWT\\" + sketchesFile.getName();
//            String outputPath = null;
            orientSketches(sketchesFile.getAbsolutePath(), outputPath);
//        orientSketches(folderPath + "256b.data", folderPath + "oriented_for_HWT\\256b.data");
        }
    }

    private static List<Integer> getIndexesToSwitchByNumberOfOnes(StreamGenericAbstractObjectIterator<Sketch> it, int sampleCount) {
        Map<Integer, Integer> bitSetsToOneCounts = new HashMap<>();
        int realCount = 0;
        for (int counter = 0; counter < sampleCount && it.hasNext(); counter++) {
            realCount++;
            Sketch sk = it.next();
            int card = 0;
            for (int i = 0; card < sk.getCardinality(); i++) {
                if (sk.getBitValue(i)) {
                    card++;
                    if (!bitSetsToOneCounts.containsKey(i)) {
                        bitSetsToOneCounts.put(i, 0);
                    }
                    bitSetsToOneCounts.put(i, bitSetsToOneCounts.get(i) + 1);
                }
            }
        }
        List<Integer> ret = new ArrayList<>();
        Iterator<Map.Entry<Integer, Integer>> bitsSetToOne = bitSetsToOneCounts.entrySet().iterator();
        while (bitsSetToOne.hasNext()) {
            Map.Entry<Integer, Integer> next = bitsSetToOne.next();
            if (next.getValue() < realCount - next.getValue()) {
                ret.add(next.getKey());
            }
        }
        try {
            it.reset();
        } catch (IOException ex) {
            Logger.getLogger(OrientBitOfSketchesViaSumOfCorrMatrix.class.getName()).log(Level.SEVERE, null, ex);
        }
        return ret;
    }

    private static BitSet getIndexesToSwitchForHWT(StreamGenericAbstractObjectIterator<Sketch> it, int sampleCount) {
        OrientBitsForHWTGlobalSum o = new OrientBitsForHWTGlobalSum(new AbstractObjectList<>(it, sampleCount));
        return o.evaluateIndexesOfBitsToSwitch();
    }

    public static void orientSketches(String sketchesPath, String outputPath) throws FileNotFoundException {
        StreamGenericAbstractObjectIterator<Sketch> it = Tools.getIterator(Sketch.class, sketchesPath);
//        List<Integer> indexesToSwitch = getIndexesToSwitchByNumberOfOnes(it, 10000);
        BitSet indexesToSwitch = getIndexesToSwitchForHWT(it, 10000000);
        Tools.orientSketches(sketchesPath, outputPath, indexesToSwitch);
        File skFile = new File(sketchesPath);
        if (!skFile.getName().startsWith("queries")) {
            String queriesFileName = new File(skFile.getParentFile(), "queries_" + skFile.getName()).getAbsolutePath();
            File o = new File(outputPath);
            String output = new File(o.getParentFile(), "queries_" + skFile.getName()).getAbsolutePath();
            Tools.orientSketches(queriesFileName, output, indexesToSwitch);
        }
    }

}
