package main.tools;

import java.io.IOException;
import java.io.PrintStream;
import java.util.Iterator;
import messif.objects.LocalAbstractObject;
import messif.objects.util.StreamGenericAbstractObjectIterator;
import messif.pivotselection.AbstractPivotChooser;
import messif.pivotselection.CoveragePivotChooser;
import messif.pivotselection.OutlierPivotChooser;

/**
 *
 * @author xmic
 */
public class PivotsSelectorFileMaker {

    public static final String storagePrefix = "c:\\Data\\2015_Doktorske\\Desc\\";

    public static void main(String[] args) throws IOException {
        String sampleSetFile = storagePrefix + "profi-neuralnet-100K.data.gz";
        StreamGenericAbstractObjectIterator<LocalAbstractObject> sampleSetIt = Tools.getIterator(args[1], sampleSetFile);
        selectCoveragePivots(sampleSetIt);
//        selectExactNumberOfPivots(sampleSetIt);
    }

    private static void selectCoveragePivots(StreamGenericAbstractObjectIterator<LocalAbstractObject> sampleSetIt) throws IOException {
        AbstractPivotChooser pivotChooser = new CoveragePivotChooser(30f);
        pivotChooser.registerSampleProvider(sampleSetIt);
        System.setOut(new PrintStream("c:\\Data\\2015_Doktorske\\Desc\\pivots_ball_partitioning\\Pivots_CoveragePivotChooser30.data"));
        int retSize = 0;
        while (retSize < 2560) {
            pivotChooser.selectPivot(2560);
            Iterator<LocalAbstractObject> pivots = pivotChooser.iterator();
            while (pivots.hasNext()) {
                LocalAbstractObject next = pivots.next();
                next.write(System.out);
                retSize++;
            }
            sampleSetIt.reset();
        }
    }

    private static void selectExactNumberOfPivots(StreamGenericAbstractObjectIterator<LocalAbstractObject> sampleSetIt) throws IOException {
        AbstractPivotChooser pivotChooser = new OutlierPivotChooser();
        pivotChooser.registerSampleProvider(sampleSetIt);
        System.setOut(new PrintStream("c:\\Data\\2015_Doktorske\\Desc\\pivots_ball_partitioning\\Pivots_KMeans.data"));
        pivotChooser.selectPivot(2560);
        Iterator<LocalAbstractObject> pivots = pivotChooser.iterator();
        while (pivots.hasNext()) {
            LocalAbstractObject next = pivots.next();
            next.write(System.out);
        }
    }
}
