/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.io.File;
import java.io.FileFilter;
import java.io.FileNotFoundException;
import java.io.FilenameFilter;
import java.io.PrintStream;
import java.util.List;
import messif.objects.util.AbstractObjectList;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.pivotAnalyzer.uncorrelatedSelector.InvertedSketchesCorrelationCounter;
import sf.pivotAnalyzer.uncorrelatedSelectorImpl.HeuristicCorrelationSubsetSearch;

/**
 *
 * @author xmic
 */
public class PrintSketchesCorrelations {

    public static void main(String[] args) throws FileNotFoundException {
//        String[] sizes = new String[]{"128"};
//        int[] sizes = new int[]{4096};
//        String[] suffixes = new String[]{"2", "4", "8", "16"};
//        String[] suffixes = new String[]{"1", "2", "4", "8", "16"};
//        String[] suffixes = new String[]{""};

        File[] paths = new File("c:\\Data\\2017\\2017_Separability\\Experiments\\DeCAF\\Sketches\\").listFiles((File dir, String name) -> name.endsWith(".data"));

        for (File file : paths) {
//            int parts = suffix.isEmpty() ? 1 : Integer.parseInt(suffix);

//            for (String size : sizes) {
//                String filePathWithSketches = "c:\\Data\\2017\\2017_11_Sketch_processing\\HWT_C_moje\\data\\sketches_messif\\MPEG7_10M\\50_50_" + size + "b.data_" + suffix + ".gz";
            String filePathWithSketches = file.getAbsolutePath();
//            String filePathWithSketches = "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\oriented_for_HWT\\" + size + "b.data";
            System.setOut(new PrintStream(filePathWithSketches + "_corrInfo"));
            AbstractObjectList<Sketch> sketches = Tools.getObjects(Sketch.class.getName(), filePathWithSketches, -1);
            System.err.println("Found " + sketches.size() + " sketches");
//        for (int i = 0; i < sketches.size(); i++) {
//            Sketch sk = sketches.get(i);
//            printSk(sk);
//        }
//        System.out.println();
            List<Sketch> invertedSketches = ObjectToSketchTransformator.tranformSketchesToInvertedSketches(sketches);
//        for (Sketch invertedSketch : invertedSketches) {
//            printSk(invertedSketch);
//        }

//                int parts = 4;
            InvertedSketchesCorrelationCounter correlationsCounter = new HeuristicCorrelationSubsetSearch(invertedSketches, sketches.size(), 0);
            float[][] sketchesCorrelations = correlationsCounter.getSketchesCorrelations(true, false);
            float corrSum = 0;
            int numberOfNegative = 0;
            int numberOfPositive = 0;
            float min = 1;
            float max = -1;
            for (int i = 0; i < sketchesCorrelations.length - 1; i++) {
                float[] corrLine = sketchesCorrelations[i];
                for (int j = i + 1; j < corrLine.length; j++) {
                    float cor = corrLine[j];
                    if (cor < 0) {
                        numberOfNegative++;
                    } else if (cor > 0) {
                        numberOfPositive++;
                    }
                    if (cor < min) {
                        min = cor;
                    }
                    if (cor > max) {
                        max = cor;
                    }
                    corrSum += cor;
                }
            }
//            System.out.println("Port: " + port);
            int parts = 1;
            int counter = sketchesCorrelations.length / parts * (sketchesCorrelations.length / parts - 1) / 2 * parts;
            System.out.println("Average correlation is " + (corrSum / counter));
            System.out.println("Min: " + min);
            System.out.println("Max: " + max);
            System.out.println("Number of negative pairwise correlations: " + numberOfNegative);
            System.out.println("Number of positive pairwise correlations: " + numberOfPositive);
//            if (counter != numberOfPositive + numberOfNegative) {
//                System.out.println("Achtung - zero correlation? Count is " + counter + " and sum of negative and positive is " + (numberOfPositive + numberOfNegative));
//            }
            System.out.println("\n\n\n\n");
        }
//        }
    }

    private static void printSk(Sketch sk) {
        for (int i = 0; i < 32; i++) {
            if (sk.getBitValue(i)) {
                System.out.print("1;");
            } else {
                System.out.print("0;");
            }
        }
        System.out.println();
    }
}
