/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools;

import java.awt.geom.Point2D;
import main.tools.oldNotUsed.SketchFromAlgorithmToFile;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.AbstractObject;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVector;
import messif.objects.impl.ObjectFloatVectorL1;
import messif.objects.util.AbstractObjectList;
import messif.objects.util.RankedAbstractObject;
import messif.objects.util.StreamGenericAbstractObjectIterator;
import messif.operations.RankingSingleQueryOperation;
import messif.pivotselection.AbstractPivotChooser;
import messif.pivotselection.OutlierPivotChooser;
import org.apache.commons.math4.stat.correlation.PearsonsCorrelation;
import org.apache.commons.math4.stat.descriptive.moment.Mean;
import sf.algorithm.HWTOP_nefunckni.Main;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.pivotAnalyzer.PivotSubsetSelector;
import sf.pivotAnalyzer.uncorrelatedSelector.InvertedSketchesCorrelationCounter;
import sf.pivotAnalyzer.uncorrelatedSelectorImpl.HeuristicCorrelationSubsetSearch;
import sf.recallEstimation.RecallEstimator;

/**
 *
 * @author xmic
 */
public class Tools {

    public static void printAnswer(RankingSingleQueryOperation op, PrintStream os, boolean newLine, boolean printFirst) {
        LocalAbstractObject query = op.getQueryObject();
        Iterator<RankedAbstractObject> result = op.getAnswer();
        if (newLine) {
            os.println();
        }
        os.println("query=" + query.getLocatorURI());
        int counter = 0;
        try {
            while (result.hasNext()) {
                RankedAbstractObject res = result.next();
                if (counter > 0) {
                    os.write(", ".getBytes());
                } else {
                    if (!printFirst) {
                        printFirst = true;
                        continue;
                    }
                }
//                String s = res.getDistance() + ": " + res.getObject().getLocatorURI();
                String s = res.getDistance() + ";";
                os.write(s.getBytes());

                counter++;
            }
            os.write('\n');
        } catch (IOException ex) {
            Logger.getLogger(Tools.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void printAnswer(RankingSingleQueryOperation op, PrintStream os) {
        printAnswer(op, os, true, true);
    }

    public static AbstractObjectList getObjects(String className, String filePath, int count) {
        StreamGenericAbstractObjectIterator<LocalAbstractObject> it = getIterator(className, filePath);
        return new AbstractObjectList(it, count);
    }

    public static Map<String, LocalAbstractObject> getObjectsAsLocatorMap(String className, String filePath, int count) {
        if (count < 0) {
            count = Integer.MAX_VALUE;
        }
        Map<String, LocalAbstractObject> ret = new HashMap<>();
        StreamGenericAbstractObjectIterator<LocalAbstractObject> it = getIterator(className, filePath);
        if (it == null) {
            return ret;
        }
        while (it.hasNext() && ret.size() < count) {
            LocalAbstractObject next = it.next();
            ret.put(next.getLocatorURI(), next);
        }
        return ret;
    }

    public static AbstractObjectList getObjects(String className, String filePath) {
        return getObjects(className, filePath, -1);
    }

    public static StreamGenericAbstractObjectIterator getIterator(Class clazz, String filePath) {
        try {
            File file = new File(filePath);
            if (!file.exists()) {
                return null;
            }
            return new StreamGenericAbstractObjectIterator(clazz, filePath);
        } catch (IOException ex) {
            Logger.getLogger(Tools.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }

    public static List<Integer> transformStringsToIntegers(List<String> set) {
        List<Integer> ret = new ArrayList<>();
        for (int i = 0; i < set.size(); i++) {
            ret.add(Integer.parseInt(set.get(i)));
        }
        return ret;
    }

    public static StreamGenericAbstractObjectIterator getIterator(String className, String filePath) {
        try {
            return getIterator(Class.forName(className), filePath);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Tools.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }

    private static void save(Iterator<AbstractObject> it, PrintStream ps) throws IOException {
        while (it.hasNext()) {
            LocalAbstractObject lao = (LocalAbstractObject) it.next();
            lao.write(ps);
        }
    }

    public static void save(Iterator<AbstractObject> it, String destPath) {
        PrintStream ps = null;
        try {
            ps = new PrintStream(destPath);
            save(it, ps);
        } catch (IOException ex) {
            Logger.getLogger(SketchFromAlgorithmToFile.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            ps.flush();
        }
    }

    public static List<String>[] parseCsvKeysValues(String path) {
        return parseCsv(path, 2);
    }

    public static List<String>[] parseCsvTriplets(String path) {
        return parseCsv(path, 3);
    }

    public static List<String>[] parseCsv(String path, int columnsNumber) {
        BufferedReader br = null;
        List<String>[] ret = new List[columnsNumber];
        for (int i = 0; i < columnsNumber; i++) {
            ret[i] = new ArrayList<>();
        }
        try {
            br = new BufferedReader(new FileReader(path));
            try {
                while (true) {
                    String line = br.readLine();
                    String[] split = line.split(";");
                    if (split.length == columnsNumber) {
                        for (int i = 0; i < columnsNumber; i++) {
                            ret[i].add(split[i]);
                        }
                    }
                }
            } catch (NullPointerException e) {
                // ignore
            }
        } catch (IOException ex) {
            Logger.getLogger(RecallEstimator.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                br.close();
            } catch (IOException ex) {
                Logger.getLogger(RecallEstimator.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return ret;
    }

    public static SortedMap<String, String> parseCsvMapStrings(String path) {
        BufferedReader br = null;
        SortedMap<String, String> ret = new TreeMap<>();
        try {
            br = new BufferedReader(new FileReader(path));
            try {
                while (true) {
                    String line = br.readLine();
                    String[] split = line.split(";");
                    if (split.length == 2) {
                        ret.put(split[0], split[1]);
                    }
                }
            } catch (NullPointerException e) {
                // ignore
            }
        } catch (IOException ex) {
            Logger.getLogger(RecallEstimator.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                br.close();
            } catch (IOException ex) {
                Logger.getLogger(RecallEstimator.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return ret;
    }

    public static SortedMap<Float, Integer> parseCsvMap(String path) {
        BufferedReader br = null;
        SortedMap<Float, Integer> ret = new TreeMap<>();
        try {
            br = new BufferedReader(new FileReader(path));
            try {
                while (true) {
                    String line = br.readLine();
                    String[] split = line.split(";");
                    if (split.length == 2) {
                        ret.put(Float.parseFloat(split[0]), Integer.parseInt(split[1]));
                    }
                }
            } catch (NullPointerException e) {
                // ignore
            }
        } catch (IOException ex) {
            Logger.getLogger(RecallEstimator.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                br.close();
            } catch (IOException ex) {
                Logger.getLogger(RecallEstimator.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return ret;
    }

    public static void printMap(Map map) {
        Set keySet = map.keySet();
        for (Object key : keySet) {
            Object value = map.get(key);
            System.out.println(key + ";" + value);
        }
    }

    public static float round(double distance, double toValue, boolean floor) {
        double add = 0;
        if (!floor) {
            add = toValue / 2;
        }
        int m = (int) ((distance + add) / toValue);
        float cur = (float) (m * toValue);
        return cur;
    }

    public static LocalAbstractObject getOutlier(String fileWithObjects, String className, int maxCount) {
        AbstractObjectList<LocalAbstractObject> objects = Tools.getObjects(className, fileWithObjects, maxCount);
        AbstractPivotChooser pivotChooser = new OutlierPivotChooser();
        pivotChooser.registerSampleProvider(objects.iterator());
        pivotChooser.selectPivot();
        return pivotChooser.iterator().next();
    }

    public static LocalAbstractObject getObject(String filePath, String objectLocator, String className) {
        Iterator<LocalAbstractObject> it = Tools.getIterator(className, filePath);
        while (it.hasNext()) {
            LocalAbstractObject next = it.next();
            if (next.getLocatorURI().equals(objectLocator)) {
                return next;
            }
        }
        return null;
    }

    public static void printCollection(Collection collection, String separator) {
        for (Object obj : collection) {
            if (obj instanceof int[]) {
                int[] intArray = (int[]) obj;
                for (int j = 0; j < intArray.length; j++) {
                    System.err.print(intArray[j] + separator + " ");
                }
                System.err.println();
            } else {
                System.err.print(obj.toString() + separator);
            }
        }
    }

    public static void printCollection(Collection collection) {
        printCollection(collection, ";");
    }

    public static int[] stringToIntArray(String string) {
        String[] split = string.split(",");
        int[] ret = new int[split.length];
        for (int i = 0; i < split.length; i++) {
            ret[i] = Integer.parseInt(split[i]);
        }
        return ret;
    }

    public static double[] floatsToDoubles(List<Float> list) {
        double[] ret = new double[list.size()];
        for (int i = 0; i < list.size(); i++) {
            Float f = list.get(i);
            ret[i] = f;
        }
        return ret;
    }

    public static void flipAndPermutatePositionsInVectors(String dataPath, String outputPath, BitSet idxToSwitch, int[] oldPermutationOfBitsAfterOrientation) throws FileNotFoundException {
        StreamGenericAbstractObjectIterator<ObjectFloatVector> it = Tools.getIterator(ObjectFloatVectorL1.class, dataPath);
        try {
            if (outputPath != null) {
                System.setOut(new PrintStream(outputPath));
            }
            int counter = 0;
            while (it.hasNext()) {
                counter++;
                ObjectFloatVector vec = it.next();
                vec = flipAndPermutatePositionsInVec(vec, idxToSwitch, oldPermutationOfBitsAfterOrientation);
//                System.out.println("");;
//                Tools.printArray(sk.getCardinalitiesInBlocks(16, 256), ",");
//                System.out.println("");;
                vec.write(System.out);
                if (counter % 10000 == 0) {
                    Logger.getLogger(Tools.class.getName()).log(Level.INFO, "Processed {0} vectors", counter);
                }
            }
            System.out.flush();
            if (outputPath != null) {
                System.out.close();
            }
        } catch (IOException ex) {
            Logger.getLogger(OrientBitOfSketchesViaSumOfCorrMatrix.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static ObjectFloatVector flipAndPermutatePositionsInVec(ObjectFloatVector vec, BitSet idxToSwitch, int[] oldPermutationOfBitsAfterOrientation) {
        float[] vectorData = vec.getVectorData();
        int lastPos = -1;
        for (int i = 0; i < idxToSwitch.cardinality(); i++) {
            lastPos = idxToSwitch.nextSetBit(lastPos + 1);
            vectorData[lastPos] = -vectorData[lastPos];
        }
        if (oldPermutationOfBitsAfterOrientation != null) {
            float[] ret = new float[vectorData.length];
            for (int i = 0; i < ret.length; i++) {
                ret[oldPermutationOfBitsAfterOrientation[i]] = vectorData[i];
            }
            return new ObjectFloatVectorL1(vec.getLocatorURI(), ret);
        }
        return new ObjectFloatVectorL1(vec.getLocatorURI(), vectorData);
    }

    public static Sketch orientSketch(Sketch sketch, BitSet idxToSwitch, int[] oldPermutationOfBitsAfterOrientation) {
        BitSet sketchCopy = sketch.getNewXoredBitSet(idxToSwitch);
        Main.t6 -= System.currentTimeMillis();
        if (oldPermutationOfBitsAfterOrientation != null) {
            Sketch newSketch = new Sketch(sketch.getLocatorURI(), oldPermutationOfBitsAfterOrientation.length);

            for (int i = sketchCopy.nextSetBit(0); i >= 0; i = sketchCopy.nextSetBit(i + 1)) {
                // operate on index c here
                newSketch.setBitValuePositive(oldPermutationOfBitsAfterOrientation[i]);
            }
//            for (int i = 0; i < newPermutationOfBitsAfterOrientation.length; i++) {
//                int oldPos = newPermutationOfBitsAfterOrientation[i];
//                if (sketchCopy.get(oldPos)) {
//                    newSketch.setBitValuePositive(i);
//                }
//            }
            Main.t6 += System.currentTimeMillis();

//            try {
//                System.out.println(sketch.getLocatorURI());
//                newSketch.write(System.out);
//            } catch (IOException ex) {
//                Logger.getLogger(Tools.class.getName()).log(Level.SEVERE, null, ex);
//            }
            return newSketch;
        }
        Main.t6 += System.currentTimeMillis();
        return new Sketch(sketch.getLocatorURI(), sketchCopy);
    }

    public static void orientSketches(String sketchesPath, String outputPath, BitSet idxToSwitch, int[] oldPermutationOfBitsAfterOrientation) throws FileNotFoundException {
        StreamGenericAbstractObjectIterator<Sketch> it = Tools.getIterator(Sketch.class, sketchesPath);
        try {
            if (outputPath != null) {
                System.setOut(new PrintStream(outputPath));
            }
            while (it.hasNext()) {
                Sketch sk = it.next();
                sk = orientSketch(sk, idxToSwitch, oldPermutationOfBitsAfterOrientation);
//                System.out.println("");;
//                Tools.printArray(sk.getCardinalitiesInBlocks(16, 256), ",");
//                System.out.println("");;
                sk.write(System.out);
            }
            System.out.flush();
            if (outputPath != null) {
                System.out.close();
            }
        } catch (IOException ex) {
            Logger.getLogger(OrientBitOfSketchesViaSumOfCorrMatrix.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void orientSketches(String sketchesPath, String outputPath, BitSet idxToSwitch) throws FileNotFoundException {
        Tools.orientSketches(sketchesPath, outputPath, idxToSwitch, null);
    }

    public static float[][] copyMatrix(float[][] matrix) {
        float[][] ret = new float[matrix.length][matrix[0].length];
        for (int i = 0; i < ret.length; i++) {
            System.arraycopy(matrix[i], 0, ret[i], 0, matrix[i].length);
        }
        return ret;
    }

    public static void printMatrix(float[][] m) {
        for (int i = 0; i < m.length; i++) {
            float[] column = m[i];
            for (int j = 0; j < column.length; j++) {
                System.err.print(column[j] + ";");
            }
            System.err.println();
        }
    }

    public static float[][] evaluateCorrelationMatrix(List<Sketch> sketches) {
        List<Sketch> invertedSketches = ObjectToSketchTransformator.tranformSketchesToInvertedSketches(sketches);
        InvertedSketchesCorrelationCounter correlationsCounter = new HeuristicCorrelationSubsetSearch(invertedSketches, sketches.size(), 0);
        return correlationsCounter.getSketchesCorrelations(false, false);
    }

    public static float[][] evaluateCorrelationMatrixForVectors(List<LocalAbstractObject> laos) {
        Logger.getLogger(Tools.class.getName()).log(Level.INFO, "Starting evaluation of correlations");
        List<float[]> inverted = Tools.createInvertedFloatVectors(laos);
        float[][] ret = new float[inverted.size()][inverted.size()];
        float[] sumX = new float[inverted.size()];
        float[] sumX2 = new float[inverted.size()];
        for (int i = 0; i < ret.length; i++) {
            ret[i][i] = 1f;
            float[] inv = inverted.get(i);
            for (int j = 0; j < inv.length; j++) {
                sumX[i] += inv[j];
                sumX2[i] += inv[j] * inv[j];
            }
        }

        for (int i = 0; i < ret.length; i++) {
            float[] v1Data = inverted.get(i);
            for (int j = i + 1; j < ret.length; j++) {
                float[] v2Data = inverted.get(j);
                ret[i][j] = evaluateCorrelationOfVecs(v1Data, v2Data, sumX[i], sumX[j], sumX2[i], sumX2[j]);
                ret[j][i] = ret[i][j];
            }
        }
        Logger.getLogger(Tools.class.getName()).log(Level.INFO, "Correlations evaluated");
        return ret;
    }

    private static float evaluateCorrelationOfVecs(float[] v1Data, float[] v2Data, float sumX, float sumY, float sumX2, float sumY2) {
        int length = v1Data.length;
        float sum1 = 0;
        for (int i = 0; i < length; i++) {
            sum1 += v1Data[i] * v2Data[i];
        }
        return (float) ((length * sum1 - sumX * sumY) / (Math.sqrt(length * sumX2 - sumX * sumX) * Math.sqrt(length * sumY2 - sumY * sumY)));
    }

    public static void printArray(int[] array, String separator) {
        for (int b : array) {
            System.out.print(b + separator);
        }
    }

    public static void printArray(float[] array, String separator) {
        for (float b : array) {
            System.out.print(b + separator);
        }
    }

    public static SortedMap sortObjectKeys(Map sketches, int[] queryCards) {
        Main.t3 -= System.currentTimeMillis();
        SortedMap<Integer, List<int[]>> ret = new TreeMap<>();
        Set<int[]> keySet = sketches.keySet();
        for (int[] key : keySet) {
            int sum = 0;
            for (int i = 0; i < key.length; i++) {
                sum += Math.abs(key[i] - queryCards[i]);
            }
            if (!ret.containsKey(sum)) {
                ret.put(sum, new ArrayList<>());
            }
            ret.get(sum).add(key);
        }
        Main.t3 += System.currentTimeMillis();
        return ret;
    }

    public static void printBitSetAsSetIndexes(BitSet ret, String separator) {
        int currIndex = 0;
        for (int i = 0; i < ret.cardinality(); i++) {
            currIndex = ret.nextSetBit(currIndex);
            System.out.print(currIndex + separator);
            currIndex++;
        }
    }

    private static List<float[]> createInvertedFloatVectors(List<LocalAbstractObject> laos) {
        if (laos.isEmpty()) {
            return new ArrayList<>();
        }
        int vecLength = ((ObjectFloatVector) laos.get(0)).getVectorData().length;
        List<float[]> ret = new ArrayList<>();
        for (int i = 0; i < vecLength; i++) {
            ret.add(new float[laos.size()]);
        }
        for (int i = 0; i < laos.size(); i++) {
            ObjectFloatVector lao = (ObjectFloatVector) laos.get(i);
            float[] vectorData = lao.getVectorData();
            for (int j = 0; j < vectorData.length; j++) {
                ret.get(j)[i] = vectorData[j];
            }
        }
        return ret;
    }

    public static void printAsPairs(LocalAbstractObject[] selectedPivots, OutputStream out) {
        try {
            for (int i = 0; i < selectedPivots.length - 1; i = i + 2) {
                String s = "\"" + selectedPivots[i].getLocatorURI() + "\";\"" + selectedPivots[i + 1].getLocatorURI() + "\"\n";
                out.write(s.getBytes());
            }
        } catch (IOException ex) {
            Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void printAsPairs(int[] selectedIndexes, OutputStream out) {
        try {
            for (int i = 0; i < selectedIndexes.length - 1; i = i + 2) {
                String s = "\"" + selectedIndexes[i] + "\";\"" + selectedIndexes[i + 1] + "\"\n";
                out.write(s.getBytes());
            }
        } catch (IOException ex) {
            Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void print(Map<LocalAbstractObject[], Float> selectedPivots, File output) {
        try {
            Tools.print(selectedPivots, new FileOutputStream(output));
        } catch (FileNotFoundException ex) {
            Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void print(Map<LocalAbstractObject[], Float> selectedPivots, OutputStream out) {
        try {
            for (Map.Entry<LocalAbstractObject[], Float> entry : selectedPivots.entrySet()) {
                LocalAbstractObject[] key = entry.getKey();
                Float ratioClosestToFirst = entry.getValue();
                String s = key[0].getLocatorURI() + ";" + key[1].getLocatorURI() + ";" + ratioClosestToFirst + "\n";
                out.write(s.getBytes());
            }
            out.flush();
        } catch (IOException ex) {
            Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static class IntArraySameLengthsComparator implements Comparator<int[]>, Serializable {

        private static final long serialVersionUID = 159756321810L;

        @Override
        public int compare(int[] o1, int[] o2) {
            for (int i = 0; i < o1.length; i++) {
                int ret = Integer.compare(o1[i], o2[i]);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }

    }

    public static class SketchMapToCardComparator implements Comparator<Map.Entry<Sketch, Integer>> {

        @Override
        public int compare(Map.Entry<Sketch, Integer> o1, Map.Entry<Sketch, Integer> o2) {
            int val1 = o1.getValue();
            int val2 = o2.getValue();
            if (val1 != val2) {
                return Integer.compare(val1, val2);
            }
            Sketch key1 = o1.getKey();
            Sketch key2 = o2.getKey();
            return key1.compareTo(key2);
        }

    }

    public static class MapByValueComparator implements Comparator<Map.Entry<Integer, Float>> {

        @Override
        public int compare(Map.Entry<Integer, Float> o1, Map.Entry<Integer, Float> o2) {
            float val1 = o1.getValue();
            float val2 = o2.getValue();
            if (val1 != val2) {
                return Float.compare(val1, val2);
            }
            Integer key1 = o1.getKey();
            Integer key2 = o2.getKey();
            return key1.compareTo(key2);
        }

    }

    public static float interpolatePoints(List<Point2D.Float> points, float x0) {
        Point2D.Float segmentStart = null;
        Point2D.Float segmentEnd = null;
        for (int i = 1; i < points.size(); i++) {
            if (points.get(i - 1).x <= x0 && points.get(i).x >= x0) {
                segmentStart = points.get(i - 1);
                segmentEnd = points.get(i);
                break;
            }
        }
        if (segmentEnd == null) {
            if (points.get(0).x >= x0) {
                return points.get(0).y;
            }
            return points.get(points.size() - 1).y;
        }
        float directive = makeDirective(segmentStart.y, segmentEnd.y, segmentStart.x, segmentEnd.x);
        return segmentStart.y + directive * (x0 - segmentStart.x);
    }

    private static float makeDirective(float y1, float y2, float x1, float x2) {
        return (y1 - y2) / (x1 - x2);
    }

    public static double pearsonCorrelationCoefficient(double[] a1, double[] a2) {
        PearsonsCorrelation evaluator = new PearsonsCorrelation();
        return evaluator.correlation(a1, a2);
    }

}
