/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools.messif3;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.MetaObject;
import messif.objects.impl.MetaObjectSAPIRWeightedDist2;
import messif.objects.impl.ObjectFloatVector;
import messif.objects.impl.ObjectFloatVectorL2;
import messif.objects.util.AbstractObjectList;
import org.json.JSONException;
import org.json.JSONObject;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class SketchIntoObjectsMuxerForMessif3 {

    public static void main(String[] args) throws JSONException, IOException {
//        processMetaObjects();
        processFloatVectors(args);
    }

    private static void processMetaObjects() throws IOException, JSONException {
        String laoFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots-2560-random.data";
//        String laoFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\1M\\metaobject.data.gz";
//        String laoFile = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\queryset-cophir-1000.data";
        String sketchesFolder = "";
//        String sketchesFolder = "c:\\Data\\2017\\Secondary_filtering\\Journal_experiments\\Cophir\\Sketches\\";
        int[] sketchesLength = new int[]{32, 48, 64, 160, 256};
        Map<String, LocalAbstractObject>[] sketches = new HashMap[sketchesLength.length];
        for (int i = 0; i < sketchesLength.length; i++) {
            int length = sketchesLength[i];
            sketches[i] = Tools.getObjectsAsLocatorMap(Sketch.class.getName(), sketchesFolder + length + "b.data", -1);
        }
        try (Writer writer = new FileWriter("c:\\Data\\2017\\Secondary_filtering\\Journal_experiments\\Cophir\\JSON_pivots_2560.data")) {
            Iterator<MetaObject> laos = Tools.getIterator(MetaObjectSAPIRWeightedDist2.class, laoFile);
            while (laos.hasNext()) {
                AbstractObjectList<MetaObject> batch = new AbstractObjectList<>(laos, 10000);
                enhanceMetaObjectsWithSketchesAndPrint(batch.iterator(), sketches, sketchesLength, writer);
                writer.flush();
            }
        }
    }

    private static void processFloatVectors(String[] args) throws IOException, JSONException {
//        String laoFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
//        String laoFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
//        String laoFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
        String laoFile = args[0];
//        String sketchesFolder = "c:\\Data\\2017\\Secondary_filtering\\Journal_experiments\\Decaf\\Sketches\\queries\\";
        String sketchesFolder = args[1];
//        String output = "c:\\Data\\2017\\Secondary_filtering\\Journal_experiments\\JSON_pivots_2560.data";
        String output = args[2];
        int[] sketchesLength = new int[]{205, 256};
        Map<String, LocalAbstractObject>[] sketches = new HashMap[sketchesLength.length];
        for (int i = 0; i < sketchesLength.length; i++) {
            int length = sketchesLength[i];
            sketches[i] = Tools.getObjectsAsLocatorMap(Sketch.class.getName(), sketchesFolder + length + "b.data", -1);
        }
        try (Writer writer = new FileWriter(output)) {
            Iterator<ObjectFloatVector> laos = Tools.getIterator(ObjectFloatVectorL2.class, laoFile);
            while (laos.hasNext()) {
                AbstractObjectList<ObjectFloatVector> batch = new AbstractObjectList<>(laos, 10000);
                enhanceFloatObjectsWithSketchesAndPrint(batch.iterator(), sketches, sketchesLength, writer);
                writer.flush();
            }
        }
    }

    private static void enhanceFloatObjectsWithSketchesAndPrint(Iterator<ObjectFloatVector> laos, Map<String, LocalAbstractObject>[] sketches, int[] sketchesLengths, Writer writer) throws JSONException, IOException {
        while (laos.hasNext()) {
            ObjectFloatVector lao = laos.next();
            String locatorURI = lao.getLocatorURI();
            String locatorWithoutZeros = Integer.toString(Integer.parseInt(locatorURI));
            JSONObject json = new JSONObject();
            json.put("_id", locatorWithoutZeros);
            float[] data = lao.getVectorData();
            json.put("decaf_float", data);
            for (int i = 0; i < sketchesLengths.length; i++) {
                int length = sketchesLengths[i];
                Sketch sketch = (Sketch) sketches[i].remove(locatorURI);
                if (sketch == null && !sketches[i].isEmpty()) {
                    throw new IllegalArgumentException("Objects do not correspond. Locator of LAO: " + locatorURI);
                }
                if (sketch != null) {
                    long[] asLongArray = sketch.getAsLongArray();
                    json.put("sk" + length + "_long", asLongArray);
                }
            }
            json.write(writer);
            writer.write(',');
            writer.write('\n');
        }
        Logger.getLogger(SketchIntoObjectsMuxerForMessif3.class.getName()).log(Level.INFO, "Processed another 10,000 objects.");
        writer.flush();
    }

    private static void enhanceMetaObjectsWithSketchesAndPrint(Iterator<MetaObject> laos, Map<String, LocalAbstractObject>[] sketches, int[] sketchesLengths, Writer writer) throws JSONException, IOException {
        while (laos.hasNext()) {
            MetaObject lao = laos.next();
            String locatorURI = lao.getLocatorURI();
            String locatorWithoutZeros = Integer.toString(Integer.parseInt(locatorURI));
            JSONObject json = new JSONObject();
            json.put("_id", locatorWithoutZeros);
            Map<String, ? extends LocalAbstractObject> objectMap = lao.getObjectMap();
            JSONObject metaObjectJSON = new JSONObject();
            for (Map.Entry<String, ? extends LocalAbstractObject> innerObj : objectMap.entrySet()) {
                String innerObjKey = innerObj.getKey();
                if (innerObjKey.equals("YCoeff")
                        || innerObjKey.equals("CrCoeff")
                        || innerObjKey.equals("CbCoeff")
                        || innerObjKey.equals("EdgeHistogramType")) {
                    innerObjKey += "_byte";
                } else if (innerObjKey.equals("energy")
                        || innerObjKey.equals("ColorStructureType")) {
                    innerObjKey += "_short";
                } else if (innerObjKey.equals("energy")
                        || innerObjKey.equals("esigma")
                        || innerObjKey.equals("ScalableColorType")) {
                    innerObjKey += "_int";
                }
                Object innerLAO = main.tools.messif3.Tools.tranformLAOforJSON(innerObj.getValue());
                metaObjectJSON.put(innerObjKey, innerLAO);
            }
            json.put("sapir", metaObjectJSON);
            for (int i = 0; i < sketchesLengths.length; i++) {
                int length = sketchesLengths[i];
                Sketch sketch = (Sketch) sketches[i].remove(locatorURI);
                if (sketch == null && !sketches[i].isEmpty()) {
                    throw new IllegalArgumentException("Objects do not correspond. Locator of LAO: " + locatorURI);
                }
                if (sketch != null) {
                    long[] asLongArray = sketch.getAsLongArray();
                    json.put("sk" + length + "_long", asLongArray);
                }
            }
            json.write(writer);
            writer.write(',');
            writer.write('\n');
        }
        Logger.getLogger(SketchIntoObjectsMuxerForMessif3.class.getName()).log(Level.INFO, "Processed another 10,000 objects.");
        writer.flush();
    }

}
