/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package main.tools.messif3;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectByteVector;
import messif.objects.impl.ObjectColorLayout;
import messif.objects.impl.ObjectGPSCoordinate;
import messif.objects.impl.ObjectHomogeneousTexture;
import messif.objects.impl.ObjectIntVector;
import messif.objects.impl.ObjectShortVector;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

/**
 *
 * @author xmic
 */
public class Tools {

    public static Object tranformLAOforJSON(LocalAbstractObject lao) throws IOException, JSONException {
        if (lao instanceof ObjectIntVector) {
            ObjectIntVector obj = (ObjectIntVector) lao;
            return obj.getVectorData();
        }
        if (lao instanceof ObjectShortVector) {
            ObjectShortVector obj = (ObjectShortVector) lao;
            return obj.getVectorData();
        }
        if (lao instanceof ObjectByteVector) {
            ObjectByteVector obj = (ObjectByteVector) lao;
            return obj.getVectorData();
        }
        if (lao instanceof ObjectHomogeneousTexture) {
            ObjectHomogeneousTexture obj = (ObjectHomogeneousTexture) lao;
            OutputStream os = new ByteArrayOutputStream();
            obj.writeData(os);
            String string = os.toString();
            string = string.replace("\n", "");
            String[] splitValues = string.split(";");
            JSONObject ret = new JSONObject();
            ret.put("avg", Integer.parseInt(splitValues[0]));
            ret.put("sigma", Integer.parseInt(splitValues[1]));
            ret.put("energy_int", main.tools.Tools.stringToIntArray(splitValues[2]));
            ret.put("esigma_int", main.tools.Tools.stringToIntArray(splitValues[3]));
            return ret;
        }
        if (lao instanceof ObjectGPSCoordinate) {
            ObjectGPSCoordinate obj = (ObjectGPSCoordinate) lao;
            JSONArray ret = new JSONArray();
            ret.put(obj.getLatitude());
            ret.put(obj.getLongitude());
            return ret;
        }
        if (lao instanceof ObjectColorLayout) {
            ObjectColorLayout obj = (ObjectColorLayout) lao;
            OutputStream os = new ByteArrayOutputStream();
            obj.writeData(os);
            String string = os.toString();
            string = string.replace("\n", "");
            String[] splitValues = string.split(";");
            JSONObject ret = new JSONObject();
            ret.put("YCoeff_byte", main.tools.Tools.stringToIntArray(splitValues[0]));
            ret.put("CbCoeff_byte", main.tools.Tools.stringToIntArray(splitValues[1]));
            ret.put("CrCoeff_byte", main.tools.Tools.stringToIntArray(splitValues[2]));
            return ret;
        }
        return lao.toString();
    }

}
