/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.algorithm.myHWT;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class OrientBitsForHWTGlobalSum extends OrientBitsForHWT {

    public OrientBitsForHWTGlobalSum(float[][] correlationMatrix) {
        super(correlationMatrix);
    }

    public OrientBitsForHWTGlobalSum(List<Sketch> sketches) {
        super(sketches);
    }

    @Override
    public BitSet evaluateIndexesOfBitsToSwitch() {
        float[] sumAndCount = evaluateMatrixSumAndCountOfNegative(bestFoundCorrelationMatrix);
        float greatestSum = sumAndCount[0];
        BitSet bestSwitches = new BitSet();
        BitSet currSwitches = new BitSet();
        int numberOfChanged = (int) (bestFoundCorrelationMatrix.length * 0.9f);
//        int numberOfChanged = 1;
        float[][] currMatrix = Tools.copyMatrix(bestFoundCorrelationMatrix);
        while (numberOfChanged > 0) {
            Logger.getLogger(OrientBitsForHWTGlobalSum.class.getName()).log(Level.INFO, "\n\nTrying to swich {0} bits:", new Object[]{numberOfChanged});
            for (int unsuccessfulAttempts = 0; unsuccessfulAttempts < currMatrix.length * 50; unsuccessfulAttempts++) {
                int[] idxs = evalIndexesWithLowestSumOfCorrs(numberOfChanged, currMatrix);
//                System.err.println("Change");
//                Tools.printCollection(Arrays.asList(idxs));
                for (int j = 0; j < idxs.length; j++) {
                    Integer idx = idxs[j];
                    currMatrix = changeBitOrientation(idx, currMatrix);
                    currSwitches.flip(idx);
                }
//                System.err.println(currSwitches.size());
                sumAndCount = evaluateMatrixSumAndCountOfNegative(currMatrix);
                if (sumAndCount[0] > greatestSum) {
                    unsuccessfulAttempts = 0;
                    greatestSum = sumAndCount[0];
                    bestSwitches = (BitSet) currSwitches.clone();
                    bestFoundCorrelationMatrix = Tools.copyMatrix(currMatrix);
                    Logger.getLogger(OrientBitsForHWTGlobalSum.class.getName()).log(Level.INFO, "Matrix sum: {0}, number of negative values: {1}", new Object[]{sumAndCount[0], sumAndCount[1]});
                }
            }
            numberOfChanged = Math.min(numberOfChanged - 1, (int) (numberOfChanged * 0.95f));
            currMatrix = Tools.copyMatrix(bestFoundCorrelationMatrix);
            currSwitches = (BitSet) bestSwitches.clone();
        }
//        float[] sumAndCount = evaluateMatrixSumAndCountOfNegative(bestFoundCorrelationMatrix);
//        System.err.println("Check: sum: " + sumAndCount[0] + ", count: " + sumAndCount[1] + ", switches count: " + bestSwitches.size());

//        System.err.println("BestFound:");
//        Tools.printMatrix(bestFoundCorrelationMatrix);
//
//        System.err.println("Original:");
//        Tools.printMatrix(backUp);
//
//        System.err.println();
//        System.err.println("Switched values: ");
//        Tools.printCollection(bestSwitches);
        return bestSwitches;
    }

    private int[] evalIndexesWithLowestSumOfCorrs(int numberOfIndexes, float[][] currMatrix) {
        List<Map.Entry<Integer, Float>> sumsPerIndexes = new ArrayList<>();
        for (int i = 0; i < currMatrix.length; i++) {
            float[] column = currMatrix[i];
            float sum = 0;
            for (int j = 0; j < column.length; j++) {
                sum += column[j];
            }
            sumsPerIndexes.add(new AbstractMap.SimpleEntry<>(i, sum));
        }
        Collections.sort(sumsPerIndexes, new Tools.MapByValueComparator());
        int[] ret = new int[numberOfIndexes];
        Iterator<Map.Entry<Integer, Float>> it = sumsPerIndexes.iterator();
        for (int i = 0; i < ret.length && it.hasNext(); i++) {
            Map.Entry<Integer, Float> next = it.next();
            ret[i] = next.getKey();
        }
        return ret;
    }
}
