//package sf.objects.impl;
//
//import java.io.BufferedReader;
//import java.io.FileReader;
//import java.io.IOException;
//import java.util.ArrayList;
//import java.util.BitSet;
//import java.util.Collection;
//import java.util.Collections;
//import java.util.Comparator;
//import java.util.HashSet;
//import java.util.Iterator;
//import java.util.List;
//import java.util.Set;
//import java.util.logging.Level;
//import java.util.logging.Logger;
//
///**
// * Sketches are created as an object bit string represetnation. Bits should be
// * uncorrelated. When inverted sketches are build (bit relates to sample set
// * objects, sketch to given pivot(s)), this class chooses the sketch indexes
// * (i.e. pivot(s) indexes), which produce mutually uncorrelated sketches.
// *
// * @author xmic
// */
//public class InvertedSketchesCorrelationCounter {
//
//    private final List<Sketch> invertedSketches;
//    private final int size;
//    private int numberOfColors;
//
//    public InvertedSketchesCorrelationCounter(List<Sketch> invertedSketches, int size) {
//        this.invertedSketches = invertedSketches;
//        this.size = size;
//    }
//
//    /**
//     * Returns matrix where field i,j contains absolute value of Pearson
//     * correlation of sketches in positions i and j.
//     *
//     * @return
//     */
//    private float[][] getSketchesCorrelations(String filePath, int size) {
//        float[][] ret = null;
//        BufferedReader br = null;
//        try {
//            br = new BufferedReader(new FileReader(filePath));
//            int counter = 0;
//            if (size <= 0) {
//                size = Integer.MAX_VALUE;
//            }
//            try {
//                while (ret == null || counter < size) {
//                    String[] floats = br.readLine().split(";");
//                    if (ret == null) {
//                        if (size == Integer.MAX_VALUE) {
//                            size = floats.length;
//                        }
//                        ret = new float[size][size];
//                    }
//                    for (int i = 0; i < size; i++) {
//                        float value = Float.parseFloat(floats[i]);
//                        ret[counter][i] = value;
//                        ret[i][counter] = value;
//                    }
//                    counter++;
//                }
//            } catch (NullPointerException ignore) {
//            }
//        } catch (IOException ex) {
//            Logger.getLogger(InvertedSketchesCorrelationCounter.class.getName()).log(Level.SEVERE, null, ex);
//        } finally {
//            try {
//                br.close();
//            } catch (IOException ex) {
//                Logger.getLogger(InvertedSketchesCorrelationCounter.class.getName()).log(Level.SEVERE, null, ex);
//            }
//        }
//        return ret;
//    }
//
//    private float[][] getSketchesCorrelations(boolean printMap) {
//        List<float[]> sketchesCardSizeAvg = new ArrayList<>();
//        float[][] ret = new float[invertedSketches.size()][invertedSketches.size()];
//        for (int i = 0; i < invertedSketches.size(); i++) {
//            sketchesCardSizeAvg.add(invertedSketches.get(i).getCardSizeCardCard2(size));
//            ret[i][i] = 1f;
//        }
//        for (int i = 0; i < invertedSketches.size() - 1; i++) {
//            for (int j = i + 1; j < invertedSketches.size(); j++) {
//                float cor = invertedSketches.get(i).getPearsonCorrelation(invertedSketches.get(j), sketchesCardSizeAvg.get(i), sketchesCardSizeAvg.get(j), size);
//                cor = Math.abs(cor);
//                ret[i][j] = cor;
//                ret[j][i] = cor;
//            }
//        }
//        if (printMap) {
//            for (int i = 0; i < invertedSketches.size(); i++) {
//                for (int j = 0; j < invertedSketches.size(); j++) {
//                    System.out.print(Float.toString(ret[i][j]) + ";");
//                }
//                System.out.println();
//            }
//        }
//        return ret;
//    }
//
//    public int[] getIndexesOfUncorrelatedSketches(int pivotCount) {
//        if (pivotCount > invertedSketches.size()) {
//            throw new IllegalArgumentException("Number of provided sketches is " + invertedSketches.size() + ". Tried to get " + pivotCount + " sketches.");
//        }
//        if (pivotCount <= 1 || pivotCount == invertedSketches.size()) {
//            throw new IllegalArgumentException("This number of returned indexes is useless. Sketches size: " + invertedSketches.size() + ". Tried to get " + pivotCount + " sketches.");
//        }
//        int sketchSize = pivotCount / 2;
////        float[][] sketchesCorrelations = getSketchesCorrelations("c:\\Data\\2015_Doktorske\\2015_Sketches\\Testy\\Korelace\\Tmp_6_invSk.csv", -1);;
//        float[][] sketchesCorrelations = getSketchesCorrelations("c:\\Data\\2015_Doktorske\\2015_Sketches\\Testy\\Korelace\\10000obj,1024pivots.csv", -1);;
////        float[][] sketchesCorrelations = getSketchesCorrelations(false);;
//        int[] properIndexes = selectUncorrelatedSubset(sketchesCorrelations, sketchSize);
//        return properIndexes;
//    }
//
//    private Set<Integer> candSetQ;
//    private Set<Integer> qMax;
//
//    private int[] selectUncorrelatedSubset(float[][] sketchesCorrelations, int sketchSize) {
//        List<Integer> vertexes = new ArrayList<>();
//        BitSet[] adjacentMatrix = getGraph(sketchesCorrelations, vertexes, sketchSize);
//        Collections.sort(vertexes, new InvertedSketchesCorrelationCounter.VertexComparatorByCardinality(adjacentMatrix));
//        List<int[]> coloring = obtainColoring(vertexes, adjacentMatrix, 0, 0);
//        candSetQ = new HashSet<>();
//        qMax = new HashSet<>();
//        maxClique(vertexes, coloring, adjacentMatrix);
//        Integer[] clique = qMax.toArray(new Integer[0]);
//        float highestCorrelation = getHighestCorrelation(clique, sketchesCorrelations);
//        Logger.getLogger(InvertedSketchesCorrelationCounter.class.getName()).log(Level.INFO, "Found subset with worst correlation {0}.", highestCorrelation);
//        int[] ret = new int[sketchSize];
//        System.arraycopy(clique, 0, ret, 0, sketchSize);
//        System.exit(1);
//        return ret;
//    }
//
//    private List<int[]> obtainColoring(Collection<Integer> vertexesR, BitSet[] adjacentMatrix, int maxCliqueSize, int curCliqueSize) {
//        int maxNumber = 0;
//        int kMin = Math.max(maxCliqueSize - curCliqueSize, 0);
//        int j = 0;
//        List<Set<Integer>> colors = new ArrayList<>();
//        colors.add(new HashSet<Integer>());
//        colors.add(new HashSet<Integer>());
//        List<Integer> vertexesRList = new ArrayList<>(vertexesR);
//        for (int i = 0; i < vertexesRList.size(); i++) {
//            int p = vertexesRList.get(i);
//            int k = 0;
//            while (intersects(colors.get(k), adjacentMatrix[p])) {
//                k++;
//            }
//            if (k > maxNumber) {
//                maxNumber = k;
//                colors.add(new HashSet<Integer>());
//            }
//            colors.get(k).add(p);
//            if (k < kMin) {
//                vertexesRList.add(j, vertexesRList.get(i));
//                j++;
//                vertexesRList.remove(j);
//            }
//        }
//        numberOfColors = maxNumber;
//        List<int[]> ret = new ArrayList<>();
//        for (int k = kMin; k <= maxNumber; k++) {
//            for (int v : colors.get(k)) {
//                ret.add(new int[]{v, k});
//            }
//        }
//        return ret;
//    }
//
//    private void maxClique(Collection<Integer> vertexes, List<int[]> coloring, BitSet[] adjacentMatrix) {
//        List<Integer> vertexesToProcessR = new ArrayList<>(vertexes);
//        while (!vertexesToProcessR.isEmpty()) {
//            Integer vertexP = selectVertextWithMaximalColor(coloring, vertexesToProcessR);
//            if (vertexP < 0) {
//                return;
//            }
//            vertexesToProcessR.remove(vertexP);
//            if (candSetQ.size() + adjacentMatrix[vertexP].size() > qMax.size()) {
//                candSetQ.add(vertexP);
//                boolean intersects = intersects(new HashSet(vertexesToProcessR), adjacentMatrix[vertexP]);
//                if (intersects) {
//                    Set<Integer> intersection = intersect(vertexesToProcessR, adjacentMatrix[vertexP]);
//                    List<int[]> newColoring = obtainColoring(intersection, adjacentMatrix, qMax.size(), candSetQ.size());
//                    maxClique(intersection, newColoring, adjacentMatrix);
//                } else if (candSetQ.size() > qMax.size()) {
//                    qMax = new HashSet<>(candSetQ);
//                    Logger.getLogger(InvertedSketchesCorrelationCounter.class.getName()).log(Level.INFO, "Found clique of size {0}", qMax.size());
//                }
//                candSetQ.remove(vertexP);
//            } else {
//                return;
//            }
//        }
//    }
//
//    private float getHighestCorrelation(Integer[] curIndexes, float[][] sketchesCorrelations) {
//        float ret = 0;
//        for (int i = 0; i < curIndexes.length - 1; i++) {
//            int idxI = curIndexes[i];
//            for (int j = i + 1; j < curIndexes.length; j++) {
//                int idxJ = curIndexes[j];
//                if (sketchesCorrelations[idxI][idxJ] > ret) {
//                    ret = sketchesCorrelations[idxI][idxJ];
//                }
//            }
//        }
//        return ret;
//    }
//
//    private BitSet[] getGraph(float[][] sketchesCorrelations, Collection<Integer> vertexes, int sketchSize) {
//        List<Float> listOfCorrelations = new ArrayList<>();
//        for (int i = 0; i < sketchesCorrelations.length - 1; i++) {
//            for (int j = i + 1; j < sketchesCorrelations.length; j++) {
//                listOfCorrelations.add(sketchesCorrelations[i][j]);
//            }
//        }
//        Collections.sort(listOfCorrelations);
//        int step = sketchesCorrelations.length * (sketchesCorrelations.length - 1) / 800;
//        numberOfColors = 0;
//        BitSet[] ret = null;
//        boolean enoughEdgesSetp0 = false;
//        float maxPermittedCorrelation = 0;
//        for (int maxCorrelationPosition = step; numberOfColors < sketchSize; maxCorrelationPosition += step) {
//            maxPermittedCorrelation = listOfCorrelations.get(maxCorrelationPosition);
//            ret = new BitSet[sketchesCorrelations.length];
//            for (int i = 0; i < sketchesCorrelations.length; i++) {
//                ret[i] = new BitSet(sketchesCorrelations.length);
//                ret[i].set(i);
//            }
//            for (int i = 0; i < sketchesCorrelations.length - 1; i++) {
//                for (int j = i + 1; j < sketchesCorrelations.length; j++) {
//                    if (sketchesCorrelations[i][j] <= maxPermittedCorrelation) {
//                        ret[i].set(j);
//                        ret[j].set(i);
//                    }
//                }
//            }
//            vertexes.clear();
//            while (vertexes.isEmpty()) {
//                ret = removeVertexOfLowDegree(ret, sketchSize - 1, vertexes);
//            }
//            if (!enoughEdgesSetp0) {
//                int sum = getAdjacentMatrixEdgesCount(ret);
//                if (sum >= sketchSize * (sketchSize - 1) / 2) {
//                    obtainColoring(vertexes, ret, 0, 0);
//                    enoughEdgesSetp0 = true;
//                }
//            } else {
//                obtainColoring(vertexes, ret, 0, 0);
//            }
//        }
//        Logger.getLogger(InvertedSketchesCorrelationCounter.class.getName()).log(Level.INFO, "Trying to find clique with worst pair correlation {0}", maxPermittedCorrelation);
//        return ret;
//    }
//
//    private int getAdjacentMatrixEdgesCount(BitSet[] adjacentMatrix) {
//        int ret = 0;
//        for (int i = 0; i < adjacentMatrix.length; i++) {
//            ret += adjacentMatrix[i].cardinality();
//        }
//        return ret;
//    }
//
//    private BitSet[] removeVertexOfLowDegree(BitSet[] adjacentMatrix, int sketchSize, Collection<Integer> vertexes) {
//        vertexes.clear();
//        // pro rucni testovani zakomentovat
//        boolean repeat = false;
//        for (int i = 0; i < adjacentMatrix.length; i++) {
//            int cardinality = adjacentMatrix[i].cardinality();
//            if (cardinality < sketchSize && cardinality > 0) {
//                adjacentMatrix[i].clear();
//                for (int j = 0; j < adjacentMatrix.length; j++) {
//                    adjacentMatrix[j].clear(i);
//                }
//                repeat = true;
//                vertexes.clear();
//            } else {
//                if (!repeat) {
//                    vertexes.add(i);
//                }
//            }
//        }
//        return adjacentMatrix;
//    }
//
//    private boolean intersects(Set<Integer> set0, BitSet set1) {
//        if (set0.isEmpty() || set1.isEmpty()) {
//            return false;
//        }
//        Iterator<Integer> it = set0.iterator();
//        while (it.hasNext()) {
//            Integer next = it.next();
//            if (set1.get(next)) {
//                return true;
//            }
//        }
//        return false;
//    }
//
//    private Integer selectVertextWithMaximalColor(List<int[]> coloring, List<Integer> vertexesToProcessR) {
//        Collections.sort(coloring, new InvertedSketchesCorrelationCounter.ColoringComparator());
//        for (int i = 0; i < coloring.size(); i++) {
//            Integer cand = coloring.get(i)[0];
//            if (vertexesToProcessR.contains(cand)) {
//                return cand;
//            }
//        }
//        return -1;
//    }
//
//    private Set<Integer> intersect(List<Integer> vertexesToProcessR, BitSet adjacentMatrix) {
//        Set<Integer> ret = new HashSet<>();
//        for (Integer vertex : vertexesToProcessR) {
//            if (adjacentMatrix.get(vertex)) {
//                ret.add(vertex);
//            }
//        }
//        return ret;
//    }
//
//    private static class ColoringComparator implements Comparator<int[]> {
//
//        @Override
//        public int compare(int[] o1, int[] o2) {
//            return Integer.compare(o2[1], o1[1]);
//        }
//    }
//
//    private static class VertexComparatorByCardinality implements Comparator<Integer> {
//
//        private final int[] sizes;
//
//        private VertexComparatorByCardinality(BitSet[] adjacentMatrix) {
//            sizes = new int[adjacentMatrix.length];
//            for (int i = 0; i < adjacentMatrix.length; i++) {
//                sizes[i] = adjacentMatrix[i].cardinality();
//            }
//        }
//
//        @Override
//        public int compare(Integer o1, Integer o2) {
//            int card1 = sizes[o1];
//            int card2 = sizes[o2];
//            int ret = Integer.compare(card2, card1);
//            if (ret != 0) {
//                return ret;
//            }
//            return o1.compareTo(o2);
//        }
//    }
//}
