package sf.deprecated;

import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.algorithms.AlgorithmMethodException;
import messif.objects.LocalAbstractObject;
import messif.objects.util.RankedSortedCollection;
import messif.objects.util.RankedSortedDistFunctionCollection;
import messif.operations.AnswerType;
import messif.operations.GetCandidateSetOperation;
import messif.operations.query.KNNQueryOperation;
import sf.algorithm.SketchAlgorithmWithRefinement;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class SketchAlgorithmWithRefinementAsymmetric extends SketchAlgorithmWithRefinement {

    public SketchAlgorithmWithRefinementAsymmetric(String name, Properties properties) throws Exception {
        super(name, properties);
    }

    @Override
    public GetCandidateSetOperation candidateSetOp(GetCandidateSetOperation op) {
        try {
            LocalAbstractObject queryObject = op.getEncapsulatedOperation().getQueryObject();
            RankedSortedCollection collection = new RankedSortedDistFunctionCollection(null, queryObject, 0f);
            KNNQueryOperation candPreselection = new KNNQueryOperation(queryObject, candidatesK, false, AnswerType.NODATA_OBJECTS, collection);
            candPreselection = parSequentialScan.executeOperation(candPreselection);
            op.addAll(candPreselection.getAnswerObjects());
            candPreselection.endOperation();
            op.endOperation();
            return op;
        } catch (AlgorithmMethodException | NoSuchMethodException ex) {
            Logger.getLogger(SketchAlgorithmWithRefinement.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }

    

}
