package sf.deprecated.vykryvaniProstoru.ballPartitioning;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import messif.objects.LocalAbstractObject;
import messif.objects.util.AbstractObjectIterator;
import messif.objects.util.AbstractObjectList;

public class PivotSelector {

    public static AbstractObjectList<LocalAbstractObject> selectPivotsWithMinDistance(AbstractObjectList objects, float minDistance, int count) {
        AbstractObjectList<LocalAbstractObject> ret = new AbstractObjectList();
        while (ret.size() != count) {
            LocalAbstractObject cand = (LocalAbstractObject) objects.randomObject();
            boolean isAppropriate = true;
            for (int i = 0; i < ret.size(); i++) {
                LocalAbstractObject pivot = ret.get(i);
                if (pivot.getDistance(cand) < minDistance) {
                    isAppropriate = false;
                    break;
                }
            }
            if (isAppropriate) {
                ret.add(cand);
            }
        }
        return ret;
    }

    public static List selectRandomPivots(AbstractObjectList objects, int count) {
        return objects.randomList(count, true, new ArrayList());
    }


    public static float[] countCover(int layersCount, AbstractObjectList objects, AbstractObjectList pivots) {
        int pivotInLayerCount = pivots.size() / layersCount;
        List<LocalAbstractObject>[] pivotsGroups = new List[layersCount];
        for (int i = 0; i < layersCount; i++) {
            pivotsGroups[i] = pivots.subList(i * pivotInLayerCount, (i + 1) * pivotInLayerCount);
        }
        AbstractObjectIterator it = objects.iterator();
        float[] ret = new float[pivots.size()];
        Arrays.fill(ret, 0);
        while (it.hasNext()) {
            LocalAbstractObject next = (LocalAbstractObject) it.next();
            for (int i = 0; i < layersCount; i++) {
                List<LocalAbstractObject> pvts = pivotsGroups[i];
                float minDist = Float.MAX_VALUE;
                int pvtIndex = -1;
                for (int j = 0; j < pvts.size(); j++) {
                    float dist = next.getDistance(pvts.get(j));
                    if (dist < minDist) {
                        minDist = dist;
                        pvtIndex = j;
                    }
                }
                if (minDist > ret[i * pivotInLayerCount + pvtIndex]) {
                    ret[i * pivotInLayerCount + pvtIndex] = minDist;
                }
            }
        }
        return ret;
    }

}
