package sf.hyperplaneDistanceDistribution;

import java.io.IOException;
import java.io.OutputStream;
import java.util.List;
import messif.objects.LocalAbstractObject;
import static main.tools.oldNotUsed.DistanceDistributionToHyperplanesExperiment.writeToOS;

/**
 *
 * @author xmic
 */
public abstract class DistanceDistibutionToDividingLineToCsv {

    protected final List<LocalAbstractObject> pivots;
    protected final List<LocalAbstractObject> objects;

    public DistanceDistibutionToDividingLineToCsv(List<LocalAbstractObject> pivots, List<LocalAbstractObject> objects) {
        this.pivots = pivots;
        this.objects = objects;
    }

    public void writeDistanceDistribution(OutputStream os, List<LocalAbstractObject[]> pivotPairs) throws IOException {
        for (int j = 0; j < objects.size(); j++) {
            LocalAbstractObject obj = objects.get(j);
            for (int i = 0; i < pivotPairs.size(); i++) {
                LocalAbstractObject piv0 = pivotPairs.get(i)[0];
                LocalAbstractObject piv1 = pivotPairs.get(i)[1];
                float d0 = obj.getDistance(piv0);
                float d1 = obj.getDistance(piv1);
                float pivDist = piv0.getDistance(piv1);
                if (d0 < d1) {
                    writeToOS(os, 0, false);
                } else {
                    writeToOS(os, 1, false);
                }
                writeToOS(os, ";", false);
                writeToOS(os, d0, false);
                writeToOS(os, ";", false);
                writeToOS(os, d1, false);
                writeToOS(os, ";", false);
                writeToOS(os, pivDist, false);
                writeToOS(os, ";", false);
                float distToHyperplane = (d0 * d0 - d1 * d1) / (2 * pivDist);
                distToHyperplane = Math.abs(distToHyperplane);
                writeToOS(os, distToHyperplane, true);
            }
        }
    }

    public abstract void writeDistanceDistribution(OutputStream os) throws IOException;

}
