package sf.hyperplaneDistanceDistribution.impl;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.TreeMap;
import messif.objects.LocalAbstractObject;
import sf.hyperplaneDistanceDistribution.DistanceDistibutionToDividingLineToCsv;

/**
 *
 * @author xmic
 */
public class DistanceDistributionToClosePivotsCouples extends DistanceDistibutionToDividingLineToCsv {

    public DistanceDistributionToClosePivotsCouples(List<LocalAbstractObject> pivots, List<LocalAbstractObject> objects) {
        super(pivots, objects);
    }

    @Override
    public void writeDistanceDistribution(OutputStream os) throws IOException {
        TreeMap<Float, LocalAbstractObject[]> minDistsPairs = new TreeMap();
        int resultSize = pivots.size() / 2;
        for (int i = 0; i < pivots.size() - 1; i++) {
            LocalAbstractObject first = pivots.get(i);
            for (int j = i + 1; j < pivots.size(); j++) {
                LocalAbstractObject second = pivots.get(j);
                float dist = first.getDistance(second);
                while (minDistsPairs.size() > resultSize) {
                    minDistsPairs.remove(minDistsPairs.lastKey());
                }
                boolean add = minDistsPairs.size() != resultSize || dist < minDistsPairs.lastKey();
                if (add) {
                    LocalAbstractObject[] pair = new LocalAbstractObject[2];
                    pair[0] = first;
                    pair[1] = second;
                    minDistsPairs.put(dist, pair);
                }
            }
        }
        List<LocalAbstractObject[]> pivotPairs = new ArrayList<>(minDistsPairs.values());
        super.writeDistanceDistribution(os, pivotPairs);
    }

}
