package sf.hyperplaneDistanceDistribution.impl;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.TreeMap;
import messif.objects.LocalAbstractObject;
import sf.hyperplaneDistanceDistribution.DistanceDistibutionToDividingLineToCsv;
import sf.hyperplaneDistanceDistribution.impl.DistanceDistributionToFarPivotsCouples.FloatDescendingComparator;

/**
 *
 * @author xmic
 */
public class DistanceDistributionToRandomPivotsCouplesBestHyperplaneDistanceValues extends DistanceDistibutionToDividingLineToCsv {

    public DistanceDistributionToRandomPivotsCouplesBestHyperplaneDistanceValues(List<LocalAbstractObject> pivots, List<LocalAbstractObject> objects) {
        super(pivots, objects);
    }

    @Override
    public void writeDistanceDistribution(OutputStream os) throws IOException {
        int pivotPairNumber = pivots.size() / 2;
        List<LocalAbstractObject[]> pivotPairs = getPivotsCandidatesByDistanceToHyperplane(pivotPairNumber);
        super.writeDistanceDistribution(os, pivotPairs);
    }

    public List<LocalAbstractObject[]> getPivotsCandidatesByDistanceToHyperplane(int pairsNumber) {
        TreeMap<Float, LocalAbstractObject[]> pivotPairsMap = new TreeMap(new FloatDescendingComparator());
        for (int i = 0; i < pivots.size() - 1; i++) {
            for (int j = i + 1; j < pivots.size(); j++) {
                LocalAbstractObject piv0 = pivots.get(i);
                LocalAbstractObject piv1 = pivots.get(j);
                float distsToHyperplaneSum = 0f;
                for (LocalAbstractObject obj : objects) {
                    float d0 = obj.getDistance(piv0);
                    float d1 = obj.getDistance(piv1);
                    float pivDist = piv0.getDistance(piv1);
                    float distToHyperplane = (d0 * d0 - d1 * d1) / (2 * pivDist);
                    distsToHyperplaneSum += Math.abs(distToHyperplane);
                }
                pivotPairsMap.put(distsToHyperplaneSum, new LocalAbstractObject[]{piv0, piv1});
                if (pivotPairsMap.size() > pairsNumber) {
                    pivotPairsMap.remove(pivotPairsMap.lastKey());
                }
            }
        }
        while (pivotPairsMap.size() > pairsNumber) {
            pivotPairsMap.remove(pivotPairsMap.lastKey());
        }
        return new ArrayList(pivotPairsMap.values());
    }

}
