/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class InvertedSketchesCreatorThread extends Thread {

    private final List<LocalAbstractObject> data;
    private final int threadId;
    private final List<Sketch> invertedSketches;
    private final ObjectToSketchTransformator transformator;
    private int curObject;
    private final int firstObject;

    public InvertedSketchesCreatorThread(List<LocalAbstractObject> data, int threadId, List<Sketch> invertedSketches, ObjectToSketchTransformator transformator, int firstObject) {
        this.data = data;
        this.threadId = threadId;
        this.invertedSketches = invertedSketches;
        this.transformator = transformator;
        this.firstObject = firstObject;
        this.curObject = firstObject;
    }

    @Override
    public void run() {
        Iterator<LocalAbstractObject> sampleSet = data.iterator();
        while (sampleSet.hasNext()) {
            LocalAbstractObject sampleObj = sampleSet.next();
            transformator.transformToInvertedFile(sampleObj, invertedSketches, curObject);
            if (curObject % 100 == 0) {
                Logger.getLogger(InvertedSketchesCreatorThread.class.getName()).log(Level.INFO, "Inverted sketches creating. Thread {1} proccesed up to object number {0}.", new Object[]{curObject, threadId});
            }
            curObject++;
        }
    }

    public int getAndResetSampleObjectNumber() {
        int ret = curObject - firstObject;
        curObject = firstObject;
        return ret;
    }

}
