/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator.impl;

import java.util.List;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVector;
import messif.objects.impl.ObjectFloatVectorNeuralNetwork;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.pivotAnalyzer.PivotSubsetSelector;

/**
 *
 * @author xmic
 */
public class BalancedBitsByComparing extends ObjectToSketchTransformator {

    int[] bitIndexes;
    final Integer floatVectorLength;

    public BalancedBitsByComparing(int floatVectorLength) {
        super(null);
        this.floatVectorLength = floatVectorLength;
        bitIndexes = new int[floatVectorLength * (floatVectorLength - 1)];
        int counter = 0;
        for (int i = 0; i < floatVectorLength - 1; i++) {
            for (int j = i + 1; j < floatVectorLength; j++) {
                bitIndexes[counter] = i;
                counter++;
                bitIndexes[counter] = j;
                counter++;
            }
        }
    }

    protected static float[] getRawVectorData(LocalAbstractObject objectToTransform) {
        if (!(objectToTransform instanceof ObjectFloatVector) && !(objectToTransform instanceof ObjectFloatVectorNeuralNetwork)) {
            return null;
        }
        float[] ret = null;
        if (objectToTransform instanceof ObjectFloatVector) {
            ret = ((ObjectFloatVector) objectToTransform).getVectorData();
//        } else {
//            ret = ((ObjectFloatVectorNeuralNetwork) objectToTransform).getRawData();
        }
        return ret;
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        float[] data = getRawVectorData(objectToTransform);
        if (data.length != floatVectorLength) {
            throw new IllegalArgumentException("Wrong length of raw data of transformed vector. Length needed: " + floatVectorLength + ", length provided: " + data.length);
        }
        Sketch ret = new Sketch(objectToTransform.getLocatorURI(), bitIndexes.length / 2);
        for (int i = 0; i < bitIndexes.length - 1; i = i + 2) {
            if (data[bitIndexes[i]] > data[bitIndexes[i + 1]]) {
                ret.setBitValuePositive(i / 2);
            }
        }
        return ret;
    }

    @Override
    public void transformToInvertedFile(LocalAbstractObject sampleObj, List<Sketch> invertedSketches, int objectNumber) {
        float[] data = getRawVectorData(sampleObj);
        for (int i = 0; i < bitIndexes.length - 1; i = i + 2) {
            float d0 = data[bitIndexes[i]];
            float d1 = data[bitIndexes[i + 1]];
            if (d0 < d1) {
                Sketch s = invertedSketches.get(i / 2);
                synchronized (s) {
                    s.setBitValuePositive(objectNumber);
                }
            }
        }
    }

    @Override
    public void removeCorrelatedBits(int[] uncorrelatedBits) {
        bitIndexes = new int[2 * uncorrelatedBits.length];
        for (int i = 0; i < uncorrelatedBits.length; i++) {
            int idx = uncorrelatedBits[i];
            bitIndexes[2 * i] = idx / (floatVectorLength - 1);
            bitIndexes[2 * i + 1] = idx % (floatVectorLength - 1) + 1;
        }
        Tools.printAsPairs(bitIndexes, System.out);
    }

    @Override
    public int getInvertedSketchesCount() {
        return bitIndexes.length / 2;
    }

}
