/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator.impl;

import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.pivotAnalyzer.CsvPivotInfoFileProcessor;
import sf.pivotAnalyzer.PivotSubsetSelector;
import sf.pivotAnalyzer.csvPivotInfoFileProcessorImpl.CsvFileBandRanges;

/**
 *
 * @author Matej Kvassay <www.matejkvassay.sk>
 */
public class BandPartitioning extends ObjectToSketchTransformator {

    private final float[] ranges1;
    private final float[] ranges2;

    public BandPartitioning(String pivotFile, String objectClass, int pivotCount, String csvFilePivotRangesInfo, boolean uniquePivots) {
        super(pivotFile, objectClass, -1);
        ranges1 = new float[pivotCount];
        ranges2 = new float[pivotCount];
        CsvPivotInfoFileProcessor pivotCreator = new CsvFileBandRanges(csvFilePivotRangesInfo, pivots, ranges1, ranges2);
        pivots = pivotCreator.getPivotsAccordingCsvLocators(pivotCount);
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        if (objectToTransform == null) {
            return null;
        }
        Sketch ret = new Sketch(objectToTransform.getLocatorURI(), pivots.length);
        for (int i = 0; i < pivots.length; i++) {
            float dist = objectToTransform.getDistance(pivots[i]);
            if (dist >= ranges1[i] && dist < ranges2[i]) {
                ret.setBitValuePositive(i);
            }
        }
        return ret;
    }

    @Override
    public void transformToInvertedFile(LocalAbstractObject sampleObj, List<Sketch> invertedSketches, int objectNumber) {
        for (int i = 0; i < pivots.length; i++) {
            float dist = sampleObj.getDistance(pivots[i]);
            if (dist >= ranges1[i] && dist < ranges2[i]) {
                invertedSketches.get(i).setBitValuePositive(objectNumber);
            }
        }
    }

    @Override
    public void removeCorrelatedBits(int[] uncorrelatedBits) {
        LocalAbstractObject[] newPivots = new LocalAbstractObject[uncorrelatedBits.length];
        for (int i = 0; i < uncorrelatedBits.length; i++) {
            int sketchIndex = uncorrelatedBits[i];
            newPivots[i] = pivots[sketchIndex];
        }
        pivots = newPivots;
        PivotSubsetSelector.printPivots(pivots, System.out);
    }

    @Override
    public int getInvertedSketchesCount() {
        return pivots.length;
    }

}
