package sf.objects.sketchcreator.impl;

import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;
import sf.objects.impl.SketchWithPivotsDistanceList;

/**
 *
 * @author xmic
 */
public class GenHyperplaneAsymmetric extends GenHyperplane {

    public GenHyperplaneAsymmetric(String pivotFile, String objectClass, int pivotCount, String csvFileWithPivotsPairs, boolean uniquePivots) {
        super(pivotFile, objectClass, pivotCount, csvFileWithPivotsPairs, uniquePivots);
    }

    public GenHyperplaneAsymmetric(String pivotFile, String objectClass, int pivotCount) {
        super(pivotFile, objectClass, pivotCount, false);
    }

    public GenHyperplaneAsymmetric(LocalAbstractObject[] pivots) {
        super(pivots);
    }

    @Override
    public void transformToInvertedFile(LocalAbstractObject sampleObj, List<Sketch> invertedSketches, int objectNumber) {
        super.transformToInvertedFile(sampleObj, invertedSketches, objectNumber); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        Sketch ret = super.transform(objectToTransform);
        if (SketchWithPivotsDistanceList.getPivotsDistanceList() == null) {
            SketchWithPivotsDistanceList.createPivotsDistanceList(pivots);
        }
        return new SketchWithPivotsDistanceList(ret);
    }

}
