package sf.operations.data;

import java.util.Iterator;
import messif.objects.LocalAbstractObject;
import messif.objects.util.AbstractObjectIterator;
import messif.objects.util.AbstractObjectList;
import messif.operations.OperationErrorCode;
import messif.operations.data.DataManipulationOperation;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class GetObjectsBySketchesOperation extends DataManipulationOperation {

    private final AbstractObjectList<Sketch> sketches;
    private AbstractObjectList<LocalAbstractObject> answer;

    public GetObjectsBySketchesOperation(Iterator sketches) {
        this(new AbstractObjectList(sketches));
    }

    public GetObjectsBySketchesOperation(AbstractObjectList sketches) {
        super();
        this.sketches = sketches;
        answer = new AbstractObjectList<>();
    }

    public AbstractObjectList<Sketch> getSketches() {
        return sketches;
    }

    public AbstractObjectList<LocalAbstractObject> getAnswer() {
        return answer;
    }

    public void addToAnswer(AbstractObjectIterator<LocalAbstractObject> objects) {
        answer.addAll(objects);
    }

    @Override
    public boolean wasSuccessful() {
        return isErrorCode(OperationErrorCode.RESPONSE_RETURNED);
    }

    @Override
    public void endOperation() {
        endOperation(OperationErrorCode.RESPONSE_RETURNED);
    }

    @Override
    protected void appendErrorCode(StringBuilder str) {
        str.append(" returned ").append(getAnswerCount()).append(" objects");
        super.appendErrorCode(str);
    }

    private Object getAnswerCount() {
        return answer.size();
    }

}
