package sf.pivotAnalyzer.threads.impl;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.LocalAbstractObject;
import sf.pivotAnalyzer.PivotSubsetSelector;
import sf.pivotAnalyzer.threads.PivotCoupleAnalyzer;

/**
 *
 * @author xmic
 */
public class HyperplanePartsSizeRatioAnalyzerAllCouples extends PivotCoupleAnalyzer {

    public HyperplanePartsSizeRatioAnalyzerAllCouples(LocalAbstractObject[] pivots, List<LocalAbstractObject> sampleObjects) {
        super(pivots, sampleObjects);
    }

    @Override
    public void run() {
        Iterator<LocalAbstractObject> sampleSetIterator = sampleObjects.iterator();
        int counter = 0;
        while (sampleSetIterator.hasNext()) {
            counter++;
            LocalAbstractObject sampleObject = sampleSetIterator.next();
            float[] distances = initDistances(sampleObject);
            for (int i = 0; i < pivots.length - 1; i++) {
                float distI = distances[i];
                for (int j = i + 1; j < pivots.length; j++) {
                    float distJ = distances[j];
                    int[] key = new int[]{i, j};
                    boolean iCloser = distI < distJ;
                    Float curValue = result.get(key);
                    if (curValue == null && iCloser) {
                        result.put(key, 1f);
                    } else if (iCloser) {
                        result.put(key, curValue + 1);
                    }
                }
            }
            if (counter % 100 == 0) {
                System.gc();
                Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.INFO, "Thread {0} processed {1} sample objects.", new Object[]{this.getId(), counter});
            }
        }
        Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.INFO, "Pivot selector map thread {0} finished. Returned {1} candidate couples.", new Object[]{this.getId(), result.size()});
    }

}
