/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.hamThresholdEstimation;

import java.io.FileNotFoundException;
import java.util.SortedMap;
import org.apache.commons.math4.distribution.AbstractRealDistribution;
import org.apache.commons.math4.distribution.LogNormalDistribution;
import sf.recallEstimation.UnivariateFunctionImpl.ProbabilitySketchBitDiffers;
import sf.recallEstimation.originalDistanceDistributionApprox.LognormalParamEstimator;
import sf.recallEstimation.pxEvaluator.PxEvaluator;

/**
 *
 * @author xmic
 */
public class TestHammingThresholdEstimatorBasedOnDistanceDensity {

    public static void main(String[] args) throws FileNotFoundException {
        // Original distance distribution to function
        // mpeg7 cophir
//        double maxDistance = 6;
//        String csvPathOrigDistanceDistribution = "c:\\Data\\2016\\2016_Recall\\Cophir_MPEG7\\Distance_distribution\\distance-distribution-sapir2-agg.csv";
//        String csvPathProbBitsDiffer = "c:\\Data\\2016\\2016_Recall\\Cophir_MPEG7\\Probabilities_that_bit_differs\\res_256b_100K_objects_average_hladke.csv";
//        int[] lengths = new int[]{32, 48, 64, 160, 256};
//        double[] iDims = new double[]{10.89d, 12.80d, 14.53d, 16.73d, 16.53d};
        // decaf profiset
        double maxDistance = 206;
        String csvPathOrigDistanceDistribution = "c:\\Data\\2016\\2016_Recall_Estimation\\Profiset_Decaf\\Distance_distribution\\l2.csv";
        String csvPathProbBitsDiffer = "c:\\Data\\2016\\2016_Recall_Estimation\\Profiset_Decaf\\Probabilities_that_bit_differs\\";
        double[] iDims = new double[]{12.20d, 17.53d, 26.07d, 28.99d, 29.37d, 21.85d};
        int[] lengths = new int[]{32, 64, 128, 205, 256};
//
        LognormalParamEstimator paramEstimator = new LognormalParamEstimator(csvPathOrigDistanceDistribution);
        double[] muSigma = paramEstimator.estimateMuSigma();
        AbstractRealDistribution f = new LogNormalDistribution(muSigma[0], muSigma[1]);

        int k = 10;
        int datasetSize = 1000000;

        System.out.println("Candidate set size;bit count;recall");
//        System.setOut(new PrintStream("c:\\Data\\2017\\Secondary_filtering\\Probabilities.csv"));
        for (int i = 0; i < lengths.length; i++) {
            int length = lengths[i];
            SortedMap<Float, Float> plotXY = PxEvaluator.parse(csvPathProbBitsDiffer + "res_" + length + "b_10K_objects_with_mu_sigma.csv");
            ProbabilitySketchBitDiffers pxProbabilitySketchBitsDiffer = new ProbabilitySketchBitDiffers(plotXY);
            Double sketchesIDim = iDims[i];
            HammingGlobalThresholdEstimatorBasedOnDistanceDensity hammingThresholdEstimator = new HammingGlobalThresholdEstimatorBasedOnDistanceDensity(datasetSize, k, maxDistance, sketchesIDim, length, f, pxProbabilitySketchBitsDiffer);
            double x0 = hammingThresholdEstimator.getX0();
            System.out.println("Sketch length=" + length + ";x0=" + x0);
            System.out.println("p(x0,b);Filtered objects from X");
            for (int b = 0; b <= length; b++) {
                double px0b = hammingThresholdEstimator.estimateProbabilityX0UpToB(b);
                double filteredObjects = hammingThresholdEstimator.estimateNumberOfFilteredObjects(b);
                System.out.println(px0b + ";" + filteredObjects);
            }
            System.out.println();
        }

    }
}
