/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.integrating;

import org.apache.commons.math4.exception.MaxCountExceededException;
import org.apache.commons.math4.exception.NotStrictlyPositiveException;
import org.apache.commons.math4.exception.NumberIsTooSmallException;
import org.apache.commons.math4.exception.TooManyEvaluationsException;

/**
 *
 * @author xmic
 */
public class OnePeakPositiveNormalizedFunctionIntegrator extends OnePeakPositiveFunctionIntegrator {

    public OnePeakPositiveNormalizedFunctionIntegrator(double mean) throws NotStrictlyPositiveException, NumberIsTooSmallException {
        super(mean);
    }

    @Override
    protected double doIntegrate() throws TooManyEvaluationsException, MaxCountExceededException {
        double minX = getMin();
        double maxX = getMax();
        double minXY = minX == Double.NEGATIVE_INFINITY ? 0 : computeObjectiveValue(minX);
        double maxXY = computeObjectiveValue(maxX);
        boolean isOne = meanX > minX && meanX < maxX && minXY < INNER_PRECISION && maxXY < INNER_PRECISION;
        if (isOne) {
            return 1d;
        }
        return super.doIntegrate();
    }

}
