/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.sketchesDistDistrForOrigDistInterval;

import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import static sf.recallEstimation.sketchesDistDistrForOrigDistInterval.TestSketchesDistDistrForOrigDistInterval.distCenter;
import static sf.recallEstimation.sketchesDistDistrForOrigDistInterval.TestSketchesDistDistrForOrigDistInterval.getSketch;
import static sf.recallEstimation.sketchesDistDistrForOrigDistInterval.TestSketchesDistDistrForOrigDistInterval.initMapCounter;
import static sf.recallEstimation.sketchesDistDistrForOrigDistInterval.TestSketchesDistDistrForOrigDistInterval.maxObjectCount;
import static sf.recallEstimation.sketchesDistDistrForOrigDistInterval.TestSketchesDistDistrForOrigDistInterval.sketchLength;
import static sf.recallEstimation.sketchesDistDistrForOrigDistInterval.TestSketchesDistDistrForOrigDistInterval.tolerance;

/**
 *
 * @author xmic
 */
public class EvaluatorThread implements Runnable {

    private final ObjectToSketchTransformator trans;
    private final List<LocalAbstractObject> dataObjs;
    private final int start;
    private final int count;
    private final Map<String, LocalAbstractObject> sketches;
    private final Map<Float, Integer> ret;
    private final AtomicInteger counter;

    public EvaluatorThread(ObjectToSketchTransformator trans, List<LocalAbstractObject> dataObjs, int start, int count, Map<String, LocalAbstractObject> sketches, AtomicInteger counter) {
        this.ret = initMapCounter(sketchLength);
        this.trans = trans;
        this.dataObjs = dataObjs;
        this.start = start;
        this.count = count;
        this.counter = counter;
        this.sketches = sketches;
    }

    public Map<Float, Integer> getRet() {
        return ret;
    }

    @Override
    public void run() {
//        Logger.getLogger(TestSketchesDistDistrForOrigDistInterval.class.getName()).log(Level.INFO, "Starts to search object pairs.");
        Random rand = new Random();
        while (true) {
            int j = rand.nextInt(dataObjs.size());
            LocalAbstractObject dataObj1 = dataObjs.get(j);
            String loc1 = dataObj1.getLocatorURI();
            int i = rand.nextInt(count);
            i += start;
            LocalAbstractObject dataObj2 = dataObjs.get(i);
            float dist = dataObj1.getDistance(dataObj2);
            if (Math.abs(dist - distCenter) <= tolerance) {
                counter.incrementAndGet();
                int counterValue = counter.intValue();
                String loc2 = dataObj2.getLocatorURI();
                Sketch sk1 = getSketch(sketches, loc1, trans, dataObj1);
                Sketch sk2 = getSketch(sketches, loc2, trans, dataObj2);
                float skDistance = sk1.getDistance(sk2);
                Integer curVal = ret.get(skDistance);
                ret.put(skDistance, curVal + 1);
                if (counterValue % 500 == 0) {
                    Logger.getLogger(TestSketchesDistDistrForOrigDistInterval.class.getName()).log(Level.INFO, "Found {0} pairs in distance {1} +- {2}. Remains to investigate {3} couples.", new Object[]{counterValue, distCenter.toString(), tolerance.toString(), (dataObjs.size() - j)});
                }
                if (counterValue >= maxObjectCount) {
                    break;
                }
            }
        }
    }

}
