/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorL2;
import sf.recallEstimation.pxEvaluator.PxEvaluatorOnCreatedSketches;
import sf.separability.measuredGeneral.QualityOfSketchingTechGenlMeas;
import sf.separabilityMeasured.QualityOfSketchingTechniqueMeasured;

/**
 *
 * @author xmic
 */
public class EstimateQualityOfSketchingTechnique {

    public static void main(String[] args) throws FileNotFoundException {
        String className = ObjectFloatVectorL2.class.getName();
        String dataFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1M.data.gz";
//        String dataFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\data\\sift-1M.data";

        Map<String, Double> medianRecalls = QualityOfSketchingTechnique.getMedianRecallsDeCAF();
//        Map<String, Double> medianRecalls = QualityOfSketchingTechnique.getMedianRecallsSIFT();

        float maxDistance = 119;
//        float maxDistance = 700;

        String output = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\PMGeneral\\Try_adbis_integral.csv";
//        String output = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\PMGeneral\\Try_adbis_integral.csv";
//        String output = null;
        if (output != null) {
            System.setOut(new PrintStream(output));
        }

//        int[] numberOfObjectsToUseParams = new int[]{3000};
//        double[] cumulativeThresholdTParams = new double[]{0.1};
//        int[] countOfIntervalsParams = new int[]{100};
//        int[] objCountParams = new int[]{0};

        int[] numberOfObjectsToUseParams = new int[]{500, 1000};
        double[] cumulativeThresholdTParams = new double[]{0.02, 0.1, 0.2};
        int[] countOfIntervalsParams = new int[]{100, 500};
        int[] objCountParams = new int[]{0, 10, 25};
//
//        int[] numberOfObjectsToUseParams = new int[]{500, 1000, 1500, 2000, 3000};
//        double[] cumulativeThresholdTParams = new double[]{0.02, 0.05, 0.1, 0.2, 0.5, 1};
//        int[] countOfIntervalsParams = new int[]{100, 200, 500, 1000, 2000};
//        int[] objCountParams = new int[]{0, 5, 10, 25, 50};
//
        for (int numberOfObjectsToUseParam : numberOfObjectsToUseParams) {
            List<LocalAbstractObject> data = Tools.getObjects(className, dataFile, numberOfObjectsToUseParam);
            Map<String[], Float> distsOnData = PxEvaluatorOnCreatedSketches.evaluateDistances(data);
            for (double cumulativeThresholdTParam : cumulativeThresholdTParams) {
                for (int countOfIntervalsParam : countOfIntervalsParams) {
                    for (int objCountParam : objCountParams) {
                        testWithParams(distsOnData, medianRecalls, numberOfObjectsToUseParam, maxDistance, cumulativeThresholdTParam, countOfIntervalsParam, objCountParam);
                    }
                }
            }
        }
    }

    private static List<Object[]> addFiles() {
        List<Object[]> ret = new ArrayList<>();
        String[] lengths = new String[]{"064", "128", "192", "256"};
        for (String length : lengths) {
            ret.add(new Object[]{"BP_50_" + length, length, 0.5f});
            ret.add(new Object[]{"GHP_50_" + length, length, 0.5f});
            ret.add(new Object[]{"GHP_80_" + length, length, 0.8f});
            ret.add(new Object[]{"THRR_50_" + length, length, 0.5f});
            ret.add(new Object[]{"NSP_50_" + length, length, 0.5f});
        }
        lengths = new String[]{"064", "128"};
        for (String length : lengths) {
//            ret.add(new Object[]{"THRR_50_" + length, length, 0.5f});
//            ret.add(new Object[]{"NSP_50_" + length, length, 0.5f});
        }
        return ret;
    }

    public static void testWithParams(Map<String[], Float> distsOnData, Map<String, Double> medianRecalls, int numberOfObjectsToUse, float maxDistance, double cumulativeThresholdT, int countOfIntervals, int objCount) {
        System.out.println("Params: maxDistance:;" + maxDistance + ";"
                + "cumulativeThresholdT:;" + cumulativeThresholdT + ";"
                + "countOfIntervals:;" + countOfIntervals + ";"
                + "numberOfObjectsToUse:;" + numberOfObjectsToUse + ";"
                + "objCount:;" + objCount);

//        String preffix = "c:\\Data\\2017\\2017_Separability\\Experiments\\SIFT\\Sketches\\"; // prepsat
        String preffix = "c:\\Data\\2017\\2017_Separability\\Experiments\\DeCAF\\Sketches\\"; // prepsat
        
        List<Object[]> sketchesFilesNamesWithLengths = addFiles();
//
        QualityOfSketchingTechniqueMeasured.MIN_NUMBER_OF_DISTANCES = objCount;
        Iterator<Object[]> it = sketchesFilesNamesWithLengths.iterator();

        float stepSize = QualityOfSketchingTechnique.getStepSize(maxDistance, countOfIntervals);
        Map<Integer, Double> distanceXDensity = QualityOfSketchingTechGenlMeas.evaluateDensityOfDistX(distsOnData, countOfIntervals, stepSize);

        Map<String, Double>[] qualityEstimations = new Map[3];
        for (int i = 0; i < qualityEstimations.length; i++) {
            qualityEstimations[i] = new HashMap<>();
        }

        while (it.hasNext()) {
            System.gc();
            Object[] next = it.next();
            String sketchesPath = preffix + next[0] + ".data";
            System.out.print(sketchesPath + ";");
            Logger.getLogger(EstimateQualityOfSketchingTechnique.class.getName()).log(Level.INFO, "Processing sketches from file {0}", sketchesPath);
            System.gc();
            Integer sketchLength = Integer.parseInt((String) next[1]);
//            float balanceOfBits = (float) next[2];

            QualityOfSketchingTechGenlMeas evaluator = new QualityOfSketchingTechGenlMeas(distanceXDensity, distsOnData, sketchesPath, sketchLength, cumulativeThresholdT, countOfIntervals, stepSize);
            double[] est = new double[3];
            est[0] = evaluator.evaluateNormalized(distanceXDensity, stepSize);
            System.out.print("Quality (norm area):;" + est[0]);
            est[1] = evaluator.evaluateNormalizedPxPy(distanceXDensity, stepSize);
            System.out.print(";Quality (norm p(x)p(y)area) is:;" + est[1]);
            est[2] = evaluator.evaluateHellinger(distanceXDensity, stepSize);
            System.out.print(";Hellinger-based quality:;" + est[2]);
            for (int i = 0; i < est.length; i++) {
                qualityEstimations[i].put((String) next[0], est[i]);
            }
            System.out.println();
        }
        double[] corr = QualityOfSketchingTechnique.getCorrelations(qualityEstimations, medianRecalls);
        for (int i = 0; i < corr.length; i++) {
            System.out.println("Correlation: " + corr[i]);
        }

    }
}
