/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability.measuredGeneral;

import java.util.Map;

import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class HellingerDistImpl extends SepDistsx1x2InHammSpace {

    private final Map<Integer, Double> distanceXDensity;
    private final Map<Integer, double[][]> conditionalDistribsForXIntervals;
    private final float step;

    public HellingerDistImpl(Map<Integer, Double> distanceXDensity, Map<Integer, double[][]> conditionalDistribsForXIntervals, float step) {
        this.conditionalDistribsForXIntervals = conditionalDistribsForXIntervals;
        this.distanceXDensity = distanceXDensity;
        this.step = step;
    }

    @Override
    public double value(double x1, double x2) {
//        System.out.print(x1 + ", " + x2 + ":: ");;
        if (x2 < x1) {
            throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
        }
        int idx1 = (int) (x1);
        int idx2 = (int) (x2);
        
        int lambda = conditionalDistribsForXIntervals.get(0)[0].length - 1;
        double ret = 0;
//      
       for (int b = 0; b <= lambda; b++) {
            ret += Math.sqrt(conditionalDistribsForXIntervals.get(idx1)[0][b] * conditionalDistribsForXIntervals.get(idx2)[0][b]);
        }

       return Math.sqrt(1-ret ); //Math.sqrt
    }
    
//    public double value2(double x1, double x2) {
////      System.out.print(x1 + ", " + x2 + ":: ");;
//      if (x2 < x1) {
//          throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
//      }
//      int idx1 = (int) (x1);
//      int idx2 = (int) (x2);
//      int lambda = conditionalDistribsForXIntervals.get(0)[0].length - 1;
//      
//      int start1=0;
//      int start2=0;
//      int end1=lambda;
//      int end2=lambda;
//      for(int b = 0; b <= lambda; b++) {
//    	  double p1=conditionalDistribsForXIntervals.get(idx1)[1][b];
//    	  double p2=conditionalDistribsForXIntervals.get(idx2)[1][b];
//    	  if(start1==0 && p1>0) {
//    		  start1=b;
//    	  }
//    	  if(start2==0 && p2>0) {
//    		  start2=b;
//    	  }
//    	  if(end1==lambda && Math.abs(1-p1)>0.0000001) {
//    		  end1=b;
//    	  }
//    	  if(end2==lambda && Math.abs(1-p2)>0.0000001) {
//    		  end2=b;
//    	  }
//    	  if(start1!=0 && start2!=0 && end1!=lambda && end2!=lambda)
//    		  break;
//      }
//      double ret = 0;
//      if(start1<=start2) {
//    	  if(end1<=end2) {
//    		  for (int b = start2; b <= end1; b++) 
//    			  ret += Math.sqrt(conditionalDistribsForXIntervals.get(idx1)[0][b] * conditionalDistribsForXIntervals.get(idx2)[0][b]);
//    		  
//    	  }
//    	  else {//end1>end2
//    		  for (int b = end2; b <= end1; b++) 
//    			  ret += (conditionalDistribsForXIntervals.get(idx1)[0][b]);
//    		  
//    	  }
//      }else {//start1>start2
//    	  if(end1<=end2) {
//    		  ret=conditionalDistribsForXIntervals.get(idx2)[0][start1];
//    		
//    	  }else {//end1>end2
//    		  ret=1;
//    		  for (int b = start2; b <= end1; b++) 
//    			  ret -= Math.sqrt(conditionalDistribsForXIntervals.get(idx1)[0][b] * conditionalDistribsForXIntervals.get(idx2)[0][b]);
//    	  }
//      }
//    	  
//     return Math.sqrt(1-ret) ;
//  }

}
