/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability.measuredGeneral;

import java.util.Map;

import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class ProbOrderPreserveImpl extends SepDistsx1x2InHammSpace {

    private final Map<Integer, Double> distanceXDensity;
    private final Map<Integer, double[][]> conditionalDistribsForXIntervals;
    private final float step;

    public ProbOrderPreserveImpl(Map<Integer, Double> distanceXDensity, Map<Integer, double[][]> conditionalDistribsForXIntervals, float step) {
        this.conditionalDistribsForXIntervals = conditionalDistribsForXIntervals;
        this.distanceXDensity = distanceXDensity;
        this.step = step;
    }

    @Override
//    public double value(double x1, double x2) { //OLD VERSION
////        System.out.print(x1 + ", " + x2 + ":: ");;
//        if (x2 < x1) {
//            throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
//        }
//        int idx1 = (int) (x1 / step);
//        int idx2 = (int) (x2 / step);
//        Double dx1 = distanceXDensity.get(idx1);
//        Double dx2 = distanceXDensity.get(idx2);
//        if (dx1 == null || dx2 == null || dx1 == 0 || dx2 == 0) {
//            return 0;
//        }
//
//        int lambda = conditionalDistribsForXIntervals.get(0)[0].length - 1;
//        double ret = 0;     
//         for (int b = 1; b <= lambda; b++) {
//            ret += conditionalDistribsForXIntervals.get(idx2)[0][b] * conditionalDistribsForXIntervals.get(idx1)[1][b-1];
//        }
//
//  //     return 1 * dx1 * dx2;
//      //     return 1;
//         return ret ;
//    }
    public double value(double x1, double x2) {
//      System.out.print(x1 + ", " + x2 + ":: ");;
        if (x2 < x1) {
            throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
        }
        int idx1 = (int) (x1);
        int idx2 = (int) (x2);
        int lambda = conditionalDistribsForXIntervals.get(0)[0].length - 1;
        double ret = 0;
        if (idx1 == idx2) {
            throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
//    	  for (int b = 0; b <= lambda; b++) 
//              ret += conditionalDistribsForXIntervals.get(idx2)[0][b] * conditionalDistribsForXIntervals.get(idx1)[1][b];

        } else {
            for (int b = 0; b <= lambda; b++) {
                ret += conditionalDistribsForXIntervals.get(idx2)[0][b] * conditionalDistribsForXIntervals.get(idx1)[1][b - 1];
            }
        }
        //   return 1;
        return ret;
    }
}
