/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability.measuredGeneral;

import java.util.Map;

import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class ProbOrderSwapImpl extends SepDistsx1x2InHammSpace {

    private final Map<Integer, Double> distanceXDensity;
    private final Map<Integer, double[][]> conditionalDistribsForXIntervals;
    private final float step;

    public ProbOrderSwapImpl(Map<Integer, Double> distanceXDensity, Map<Integer, double[][]> conditionalDistribsForXIntervals, float step) {
        this.conditionalDistribsForXIntervals = conditionalDistribsForXIntervals;
        this.distanceXDensity = distanceXDensity;
        this.step = step;
    }

    @Override
    public double value(double x1, double x2) {
//        System.out.print(x1 + ", " + x2 + ":: ");;
        if (x2 < x1) {
            throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
        }
        int idx1 = (int) (x1);
        int idx2 = (int) (x2);
        
        int lambda = conditionalDistribsForXIntervals.get(0)[0].length - 1;
        double ret = 0;
//      
        	 for (int b = 0; b <= lambda; b++) {
            ret += conditionalDistribsForXIntervals.get(idx1)[0][b] * conditionalDistribsForXIntervals.get(idx2)[1][b];
        }
      return ret ;
    }

}
