/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability;

import org.apache.commons.math4.analysis.BivariateFunction;
import sf.separabilityAnalytique.BivariateIntegrator;

/**
 *
 * @author xmic
 */
public abstract class QualityOfSketchingTechnique {

    protected final double maxDistance;

    protected QualityOfSketchingTechnique(double maxDistance) {
        this.maxDistance = maxDistance;
    }

    public double evaluateNormalized() {
        return evaluateNormalized(-1d);
    }

    public double evaluateNormalized(double maxX1, double stepIntegrating) {
        BivariateFunction sepx1x2 = createInstanceSepDistsx1x2InHammSpace();
        BivariateIntegrator integrator;
        if (maxX1 >= 0) {
            integrator = new BivariateIntegrator(sepx1x2, 0, maxDistance, maxX1, stepIntegrating);
        } else {
            integrator = new BivariateIntegrator(sepx1x2, 0, maxDistance, maxDistance, stepIntegrating);
        }
        double quality = integrator.evaluate();
        return quality / maxDistance / maxDistance;
    }

    public double evaluateNormalized(double maxX1) {
        BivariateFunction sepx1x2 = createInstanceSepDistsx1x2InHammSpace();
        BivariateIntegrator integrator;
        if (maxX1 >= 0) {
            integrator = new BivariateIntegrator(sepx1x2, 0, maxDistance, maxX1);
        } else {
            integrator = new BivariateIntegrator(sepx1x2, 0, maxDistance);
        }
        double quality = integrator.evaluate();;;
//        return quality / maxDistance / maxDistance;
        return quality;
    }

    protected abstract BivariateFunction createInstanceSepDistsx1x2InHammSpace();

}
