/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability.measuredGeneral;

import java.util.Map;
import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class ProbOrderPreserveImpl extends SepDistsx1x2InHammSpace {

    private final Map<Integer, Float> distanceXDensity;
    private final Map<Integer, float[][]> conditionalDistribsForXIntervals;
    private final int distInterval;

    public ProbOrderPreserveImpl(Map<Integer, Float> distanceXDensity, Map<Integer, float[][]> conditionalDistribsForXIntervals, int distInterval) {
        this.conditionalDistribsForXIntervals = conditionalDistribsForXIntervals;
        this.distanceXDensity = distanceXDensity;
        this.distInterval = distInterval;
    }

    @Override
    public double value(double x1, double x2) {
//        System.out.print(x1 + ", " + x2 + ":: ");;
        if (x2 < x1) {
            throw new IllegalArgumentException("Wrong parameters for an integral: " + x1 + ", " + x2);
//            return -Double.MAX_VALUE;
        }
        int idx1 = (int) (x1 / distInterval);
        int idx2 = (int) (x2 / distInterval);
        Float dx1 = distanceXDensity.get(idx1);
        Float dx2 = distanceXDensity.get(idx2);
        if (dx1 == null || dx2 == null || dx1 == 0 || dx2 == 0) {
            return 0;
        }
//        if (dx1 == null || dx2 == null) {
//            return 0;
//        }
        int lambda = conditionalDistribsForXIntervals.get(0)[0].length - 1;
        double ret = 0;
        for (int b = 1; b <= lambda; b++) {
            ret += conditionalDistribsForXIntervals.get(idx1)[1][b - 1] * conditionalDistribsForXIntervals.get(idx2)[0][b];
//            ret += conditionalDistribsForXIntervals.get(idx2)[1][b - 1] * conditionalDistribsForXIntervals.get(idx1)[0][b];
        }
//        return ret;
//        System.out.print(" prob x1, x2: " + dx1 + ", " + dx2 + "::: ");;
        return ret * dx1 * dx2;
    }

}
