/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.algorithm.myHWT;

import java.util.BitSet;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public abstract class OrientBitsForHWT {

    protected float[][] bestFoundCorrelationMatrix;
    public float bestCorrSumFound;

    public OrientBitsForHWT(float[][] correlationMatrix) {
        this.bestFoundCorrelationMatrix = correlationMatrix;
        float[] sumAndCount = evaluateMatrixSumAndCountOfNegative(bestFoundCorrelationMatrix);
        Logger.getLogger(OrientBitsForHWTGlobalSum.class.getName()).log(Level.INFO, "Matrix sum: {0}, number of negative values: {1}", new Object[]{sumAndCount[0], sumAndCount[1]});
    }

    public OrientBitsForHWT(List<Sketch> sketches) {
        this.bestFoundCorrelationMatrix = Tools.evaluateCorrelationMatrix(sketches);
//        backUp = Tools.copyMatrix(bestFoundCorrelationMatrix);
        float[] sumAndCount = evaluateMatrixSumAndCountOfNegative(bestFoundCorrelationMatrix);
        Logger.getLogger(OrientBitsForHWTGlobalSum.class.getName()).log(Level.INFO, "Matrix sum: {0}, number of negative values: {1}", new Object[]{sumAndCount[0], sumAndCount[1]});
    }


    protected final float[] evaluateMatrixSumAndCountOfNegative(float[][] matrix) {
        float[] ret = new float[]{0, 0};
        for (int i = 0; i < matrix.length - 1; i++) {
            for (int j = i + 1; j < matrix.length; j++) {
                ret[0] += matrix[i][j];
                if (matrix[i][j] < 0) {
                    ret[1] += 1;
                }
            }
        }
        return ret;
    }

    public abstract BitSet evaluateIndexesOfBitsToSwitch();

    protected float[][] changeBitOrientation(int idx, float[][] currMatrix) {
        for (int i = 0; i < currMatrix.length; i++) {
            currMatrix[idx][i] = -currMatrix[idx][i];
            currMatrix[i][idx] = -currMatrix[i][idx];
        }
        return currMatrix;
    }

}
