/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.algorithm.myHWT;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import messif.algorithms.Algorithm;
import messif.algorithms.AlgorithmMethodException;
import messif.buckets.CapacityFullException;
import messif.objects.util.RankedAbstractObject;
import messif.operations.data.BulkInsertOperation;
import messif.operations.query.KNNQueryOperation;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class SketchPreciseAlgorithm2 extends Algorithm {

    private final Map<int[], List<Sketch>> sketches = new TreeMap<>(new Tools.IntArraySameLengthsComparator());
    private final int numberOfBlocks;
    private final int sketchLength;

    public SketchPreciseAlgorithm2(String algorithmName, int numberOfBlocks, int sketchLength) throws IllegalArgumentException {
        super(algorithmName);
        this.numberOfBlocks = numberOfBlocks;
        this.sketchLength = sketchLength;
        Logger.getLogger(SketchPreciseAlgorithm2.class.getName()).log(Level.INFO, "Max number of buckets is approximately {0}", Math.pow(sketchLength / numberOfBlocks + 1, numberOfBlocks));
    }

    static float sum = 0;

    public static void main(String[] args) throws CapacityFullException, InstantiationException, FileNotFoundException {
        int sum = 0;
        for (int i = 0; i < 13; i++) {
            Set<int[]> col = getAllKeysInDistance(i, new int[]{16, 16, 16, 16});
            sum += col.size();
        }
        System.out.println("Pocet: " + sum);
        System.exit(0);
        int[] blocks = new int[]{2, 4, 8, 16};
//        int[] blocks = new int[]{16};
        for (int block : blocks) {
            sum = 0;
            try {
                int k = 10;
                String s = "75_25";
//                System.setOut(new PrintStream("c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\Saved_dist_comps_oriented_per_partes_permutated\\k" + k + "\\Results_" + s + "_" + block + "_k" + k + ".csv"));
                int sketchLength = 256;
                Algorithm alg = new SketchPreciseAlgorithm2("MyAlgorithm", block, sketchLength);
//                Algorithm alg = new ParallelSequentialScan(1);
                Iterator dataIt = Tools.getIterator(Sketch.class, "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\" + sketchLength + "b.data");
//                Iterator dataIt = Tools.getIterator(Sketch.class, "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\oriented_for_HWT_per_partes_switched\\" + sketchLength + "b.data");
//                Iterator dataIt = Tools.getIterator(Sketch.class, "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\50_50\\oriented_for_HWT\\" + sketchLength + "b.data");
//                Iterator dataIt = Tools.getIterator(Sketch.class, "c:\\Data\\2016_orientedSketches\\DeCAF_Profiset\\Orientace_dle_outlier_0000028271\\1M_" + sketchLength + "_bits.txt");
//                Iterator dataIt = Tools.getIterator(Sketch.class, "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\sketches\\sketches-19120.data");
//                Iterator dataIt = Tools.getIterator(Sketch.class, "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\Oriented\\sketches-28000.data");
                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\oriented_for_HWT_per_partes_switched\\queries_" + sketchLength + "b.data", -1);
//                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\decaf\\sketches\\50_50\\oriented_for_HWT_per_partes_switched\\queries_" + sketchLength + "b.data", -1);
//                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2017\\2017_11_Sketch_processing\\sketches\\cophir\\sketches\\50_50\\queries_" + sketchLength + "b.data", -1);
//                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2016_orientedSketches\\DeCAF_Profiset\\Orientace_dle_outlier_0000028271\\Queries-1000_" + sketchLength + "_bits.txt", -1);
//                List<Sketch> queries = Tools.getObjects(Sketch.class.getName(), "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\" + s + "\\sketches\\Oriented\\queries_256b.data", -1);
//            List<Sketch> queries = SketchPreciseAlgorithm.getQueries(false, sketchLength);
                BulkInsertOperation insert = new BulkInsertOperation(dataIt);
                alg.executeOperation(insert);

//            int range = 36;
                for (Sketch query : queries) {
                    KNNQueryOperation op = new KNNQueryOperation(query, k);
//                RangeQueryOperation op = new RangeQueryOperation(query, range);
                    alg.executeOperation(op);
                    Iterator<RankedAbstractObject> answer = op.getAnswer();
                    float max = 0;
                    while (answer.hasNext()) {
                        RankedAbstractObject next = answer.next();
//                        if (next.getObject().getLocatorURI().equals(query.getLocatorURI())) {
//                            System.out.println("Achtung! The exact match on query object!");
//                        }
                        float d = next.getDistance();
                        if (d > max) {
                            max = d;
                        }
                    }
                    sum += max;
//                    System.out.println(max);
                }
                System.out.println("Average range: " + (sum / queries.size()));
            } catch (AlgorithmMethodException | NoSuchMethodException ex) {
                Logger.getLogger(SketchPreciseAlgorithm.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void insertObjects(BulkInsertOperation op) {
        Iterator<Sketch> insertedObjects = (Iterator<Sketch>) op.getInsertedObjects().iterator();
        while (insertedObjects.hasNext()) {
            Sketch sketch = insertedObjects.next();
            int[] cardinalitiesInBlocks = sketch.getCardinalitiesInBlocks(numberOfBlocks, sketchLength);
            if (!sketches.containsKey(cardinalitiesInBlocks)) {
                List<Sketch> list = new ArrayList<>();
                sketches.put(cardinalitiesInBlocks, list);
            }
            sketches.get(cardinalitiesInBlocks).add(sketch);
        }
        for (int[] leaf : sketches.keySet()) {
            System.err.println(sketches.get(leaf).size());
        }
        System.exit(0);
        Logger.getLogger(SketchPreciseAlgorithm2.class.getName()).log(Level.INFO, "Objects inserted. Currently are occupied {0} buckets", sketches.size());
        op.endOperation();
    }

//    public KNNQueryOperation knnSearchWithGeneratingCoords(KNNQueryOperation op) {
//        int counter = 0;
//        Sketch querySketch = (Sketch) op.getQueryObject();
//        int[] queryCards = querySketch.getCardinalitiesInBlocks(numberOfBlocks, sketchLength);
//        int minimalDistanceOfCurList = 0;
//        float answerDistance = Sketch.MAX_DISTANCE;
//        long t2 = 0;
//        while (minimalDistanceOfCurList < answerDistance) {
//            List<int[]> keys = getAllKeysInDistance(minimalDistanceOfCurList, queryCards);
//            if (keys != null) {
//                for (int[] key : keys) {
//                    if (minimalDistanceOfCurList == answerDistance) {
//                        break;
//                    }
//                    if (!sketches.containsKey(key)) {
//                        continue;
//                    }
//                    List<Sketch> sublist = sketches.get(key);
//                    t2 -= System.currentTimeMillis();
//                    for (Sketch dataObject : sublist) {
//                        op.addToAnswer(dataObject);
//                    }
//                    t2 += System.currentTimeMillis();
//                    counter += sublist.size();
//                    if (op.isAnswerFull()) {
//                        answerDistance = op.getAnswerDistance();
//                    }
//                }
//            }
//            minimalDistanceOfCurList++;
//        }
//        System.out.println("Adding to answer     : " + t2 + "; " + counter + " objects;  saved: " + (100 - counter / 10000f) + " %, kNN dist: " + minimalDistanceOfCurList);
//        op.endOperation();
//        savedDistanceComputations.add(100 - counter / 10000f);
//        return op;
//    }
    public KNNQueryOperation knnSearchWithSorting(KNNQueryOperation op) {
        int counter = 0;
        Sketch querySketch = (Sketch) op.getQueryObject();
        int[] queryCards = querySketch.getCardinalitiesInBlocks(numberOfBlocks, sketchLength);
        float answerDistance = Sketch.MAX_DISTANCE;
        SortedMap<Integer, List<int[]>> lowerBoundedKeys = Tools.sortObjectKeys(sketches, queryCards);
        int minimalDistanceOfCurList = 0;
        while (minimalDistanceOfCurList < answerDistance) {
            List<int[]> keys = lowerBoundedKeys.get(minimalDistanceOfCurList);
            if (keys != null) {
                for (int[] key : keys) {
                    if (minimalDistanceOfCurList < answerDistance) {
                        List<Sketch> sublist = sketches.get(key);
                        for (Sketch dataObject : sublist) {
                            op.addToAnswer(dataObject);
                            counter++;
                        }
                        if (op.isAnswerFull()) {
                            answerDistance = op.getAnswerDistance();
                        }
                    }
                }
            }
            minimalDistanceOfCurList++;
        }
        op.endOperation();
        System.out.println(100 - counter / 10000f);
//        System.err.println("Pocet: " + counter + ", uspora: " + (100 - counter / 10000f) + " %, posledni vzdalenost: " + minimalDistanceOfCurList);
        return op;
    }
//    public RangeQueryOperation rangeSearch(RangeQueryOperation op) {
//        int counter = 0;
//        int radius = (int) op.getRadius();
//        Sketch querySketch = (Sketch) op.getQueryObject();
//        int queryCard = querySketch.getCardinality();
//        int minimalDistanceOfCurList = 0;
//        while (minimalDistanceOfCurList < radius) {
//            Integer key = queryCard + minimalDistanceOfCurList;
//            if (/*key > addAllUpToLimit && key < addAllFromLimit && */sketches.containsKey(key)) {
//                List<Sketch> sublist = sketches.get(key);
//                for (Sketch dataObject : sublist) {
//                    op.addToAnswer(dataObject, radius);
//                    counter++;
//                }
//            }
//            key = queryCard - minimalDistanceOfCurList;
//            if (minimalDistanceOfCurList != 0 && minimalDistanceOfCurList <= radius && /*key > addAllUpToLimit && key < addAllFromLimit && */ sketches.containsKey(key)) {
//                List<Sketch> sublist = sketches.get(key);
//                for (Sketch dataObject : sublist) {
//                    op.addToAnswer(dataObject, radius);
//                    counter++;
//                }
//            }
//            minimalDistanceOfCurList++;
//        }
//        op.endOperation();
//        savedDistanceComputations.add(100 - counter / 10000f);
//        return op;
//    }
//

    @Deprecated
    private Set<int[]> getKeysInDistanceBySeqScan(int distOfList, int[] queryCards) {
        Set ret = new HashSet<>();
        Set<int[]> keySet = sketches.keySet();
        for (int[] key : keySet) {
            int sum1 = 0;
            for (int i = 0; i < key.length; i++) {
                sum1 += Math.abs(key[i] - queryCards[i]);
            }
            if (sum1 == distOfList) {
                ret.add(key);
            }
        }
        return ret;
    }

    @Deprecated // spatne
    public static Set<int[]> getAllKeysInDistance(int dist, int[] queryCards) {
        Set<int[]> ret = new TreeSet<>(new Comparator<int[]>() {

            @Override
            public int compare(int[] o1, int[] o2) {
                for (int i = 0; i < o1.length; i++) {
                    if (o1[i] != o2[i]) {
                        return Integer.compare(o1[i], o2[i]);
                    }
                }
                return 0;
            }
        });
        int[] startVector = new int[queryCards.length];
        startVector[0] = queryCards[0] - dist;
        System.arraycopy(queryCards, 1, startVector, 1, startVector.length - 1);
        Collection<int[]> batch = new HashSet<>();
        ret.add(startVector);
        batch.add(startVector);
//        Tools.printCollection(Collections.singletonList(startVector));
//        System.out.println("");;
        int curZeroAxis = startVector[0];
        while (true) {
            batch = iterate(curZeroAxis, batch, queryCards[0], 1, queryCards);
            if (batch.isEmpty()) {
                break;
            }
//            Tools.printCollection(batch);;
//            System.out.println("");;
            ret.addAll(batch);
            curZeroAxis++;
        }
        if (dist == 0) {
            return ret;
        }
        startVector = new int[queryCards.length];
        startVector[0] = queryCards[0] + dist;
        System.arraycopy(queryCards, 1, startVector, 1, startVector.length - 1);
        ret.add(startVector);
        batch.clear();
        batch.add(startVector);
//        Tools.printCollection(Collections.singletonList(startVector));
//        System.out.println("");;
        curZeroAxis = startVector[0];
        while (true) {
            batch = iterate(curZeroAxis, batch, queryCards[0], -1, queryCards);
            if (batch.isEmpty()) {
                break;
            }
//            Tools.printCollection(batch);;
//            System.out.println("");;
            ret.addAll(batch);
            curZeroAxis--;
        }
        System.out.println(dist + ";" + ret.size());
        return ret;
    }

    private static Collection<int[]> iterate(int curZeroAxis, Collection<int[]> batch, int limitForZeroAxis, int incr, int[] queryCards) {
        Collection<int[]> ret = new ArrayList<>();
        curZeroAxis += incr;
        if ((curZeroAxis > limitForZeroAxis && incr == 1) || (curZeroAxis <= limitForZeroAxis && incr == -1)) {
            return ret;
        }
        for (int[] point : batch) {
            for (int i = 1; i < point.length; i++) {
                if (point[i] >= queryCards[i]) {
                    int[] add1 = getUpdatedPoint(point, curZeroAxis, i, 1);
                    ret.add(add1);
                }
                if (point[i] <= queryCards[i]) {
                    int[] add2 = getUpdatedPoint(point, curZeroAxis, i, -1);
                    ret.add(add2);
                }
            }
        }
        return ret;
    }

    private static int[] getUpdatedPoint(int[] point, int curZeroAxis, int idx, int inc) {
        int[] ret = new int[point.length];
        System.arraycopy(point, 0, ret, 0, point.length);
        ret[0] = curZeroAxis;
        ret[idx] += inc;
        return ret;
    }
}
