/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.deprecated;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorNeuralNetworkL2;
import messif.objects.util.AbstractObjectList;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.objects.sketchcreator.impl.GenHyperplane;

/**
 *
 * @author xmic
 */
public class EvaluateKNNOnSketches {

    public static final Integer LENGTH = 64;
    public static final String CSV_FILE = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots_filtered_hyperplane\\512_random\\UncorrelatedPivots_" + LENGTH + "_pairs.csv";
    public static final Integer PORT = 20010;

    public static final String SKETCH_FILE = "c:\\Data\\2016\\Filtrovani_MIndexu\\Cophir\\Sketches\\sketches-" + PORT + ".data";
    public static final String QUERY_FILE = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\queryset-cophir-1000.data";
    public static final String PIVOT_FILE = "c:\\Data\\2015_Doktorske\\Desc\\cophir\\mpeg7\\pivots-512-random.data";

    public static void main(String[] args) throws FileNotFoundException {
        AbstractObjectList<LocalAbstractObject> queries = Tools.getObjects(ObjectFloatVectorNeuralNetworkL2.class.getName(), QUERY_FILE, -1);
        AbstractObjectList<LocalAbstractObject> sketches = Tools.getObjects(Sketch.class.getName(), SKETCH_FILE, -1);
        ObjectToSketchTransformator objectToSketchTranformator = new GenHyperplane(PIVOT_FILE, ObjectFloatVectorNeuralNetworkL2.class.getName(), LENGTH, CSV_FILE, false);
        try (PrintStream out = new PrintStream("results_" + PORT)) {
            System.setOut(out);
            for (Iterator<LocalAbstractObject> it = queries.iterator(); it.hasNext();) {
                LocalAbstractObject query = it.next();
                Sketch querySketch = objectToSketchTranformator.transform(query);
                System.out.println("query=" + query.getLocatorURI());
                for (int i = 0; i < sketches.size(); i++) {
                    LocalAbstractObject sketch = sketches.get(i);
                    if (i != 0) {
                        System.out.print(", ");
                    }
                    System.out.print(querySketch.getDistance(sketch) + ": " + sketch.getLocatorURI());
                }
                System.out.println("");
                Logger.getLogger(EvaluateKNNOnSketches.class.getName()).log(Level.INFO, "Processed query {0}", query.getLocatorURI());
            }
            out.flush();
        }
    }

//    public static final String ALGS_FOLDER = "c:\\Data\\2016\\indexes\\";
//    public static final Integer K = 1000000;
//    public static void mainOld(String[] args) {
//        AbstractObjectList<LocalAbstractObject> queries = PivotSelector.getObjects(ObjectFloatVectorNeuralNetworkL2.class.getName(), QUERY_FILE, -1);
//        int port = 20010;
//        try {
//            try (PrintStream out = new PrintStream("results_" + port)) {
//                System.setOut(out);
//                String path = ALGS_FOLDER + "sketches-" + port + "\\serialized\\SketchAlg.alg";
//                SketchAlgorithm alg = Algorithm.restoreFromFile(path, SketchAlgorithm.class);
//                ParallelSequentialScan parSequentialScan = alg.getParSequentialScan();
//                int len = 64;;
//                ObjectToSketchTransformator objectToSketchTranformator = new GenHyperplane(PIVOT_FILE, ObjectFloatVectorNeuralNetworkL2.class.getName(), len, "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots_filtered_hyperplane\\512_random\\UncorrelatedPivots_022_64_pairs.csv", false);;
//                for (LocalAbstractObject query : queries) {
//                    Sketch querySketch = objectToSketchTranformator.transform(query);
//                    KNNQueryOperation knn = new KNNQueryOperation(querySketch, K);
//                    System.err.println("C: " + System.currentTimeMillis());
//                    knn = parSequentialScan.executeOperation(knn);
//                    System.err.println("D: " + System.currentTimeMillis());
//                    knn.endOperation();
//                    KNNApproxEvaluation.printAnswer(knn, System.out);
//                }
//                out.flush();
//            }
//        } catch (IOException | NullPointerException | ClassNotFoundException | ClassCastException | AlgorithmMethodException | NoSuchMethodException ex) {
//            Logger.getLogger(EvaluateKNNOnSketches.class.getName()).log(Level.SEVERE, null, ex);
//        }
//    }
}
