package sf.deprecated.vykryvaniProstoru;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Objects;
import static main.tools.oldNotUsed.DistanceDistributionToHyperplanesExperiment.floatToByteArrayForPrint;
import sf.deprecated.vykryvaniProstoru.ballPartitioning.variableRanges.Experiment02;

/**
 *
 * @author xmic
 */
public class ResultHolder implements Comparable<ResultHolder> {

    private final String queryLocator;
    private final String objectLocator;
    private final float distance;
    private final Comparable deviation;

    public ResultHolder(String queryLocator, String objectLocator, float distance, Comparable minQueryDeviation) {
        this.queryLocator = queryLocator;
        this.objectLocator = objectLocator;
        this.distance = distance;
        this.deviation = minQueryDeviation;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 17 * hash + Objects.hashCode(this.queryLocator);
        hash = 17 * hash + Objects.hashCode(this.objectLocator);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ResultHolder other = (ResultHolder) obj;
        if (!Objects.equals(this.queryLocator, other.queryLocator)) {
            return false;
        }
        return Objects.equals(this.objectLocator, other.objectLocator);
    }

    @Override
    public int compareTo(ResultHolder o) {
        int ret = deviation.compareTo(o.deviation);
        if (ret != 0) {
            return ret;
        }
        if (distance != o.distance) {
            return Float.compare(distance, o.distance);
        }
        if (!queryLocator.equals(o.queryLocator)) {
            return queryLocator.compareTo(o.queryLocator);
        }
        return objectLocator.compareTo(o.objectLocator);
    }

    public void write(OutputStream os) throws IOException {
        os.write(floatToByteArrayForPrint(distance));
        os.write(';');
        if (deviation instanceof Float) {
            os.write(floatToByteArrayForPrint((Float) deviation));
            os.write(';');
        }
        if (deviation instanceof Experiment02.Result) {
            Experiment02.Result devRes = (Experiment02.Result) deviation;
            os.write(floatToByteArrayForPrint(devRes.getMaxR()));
            os.write(';');
            os.write(floatToByteArrayForPrint(devRes.getMinR()));
            os.write(';');
            os.write(floatToByteArrayForPrint(devRes.getMaxR() - devRes.getMinR()));
            os.write(';');
        }
        os.write(queryLocator.getBytes());
        os.write(';');
        os.write(objectLocator.getBytes());
        os.write('\n');
    }

}
