package sf.deprecated.vykryvaniProstoru.ballPartitioning.ballSketches;

import java.util.List;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;
import messif.objects.LocalAbstractObject;
import sf.deprecated.vykryvaniProstoru.Experiment;
import sf.deprecated.vykryvaniProstoru.ResultHolder;
import sf.objects.impl.PivotsDistanceList;
import sf.objects.impl.Sketch;


/**
 *
 * @author xmic
 */
public class Experiment03 implements Experiment {

    @Override
    public SortedSet<ResultHolder> evaluateQuery(LocalAbstractObject query, Map<LocalAbstractObject, Sketch> signatureFiles, PivotsDistanceList pivotDistanceList) {
        SortedSet<ResultHolder> ret = new TreeSet();
        List<LocalAbstractObject> pivots = pivotDistanceList.getPivots();
        Sketch querySketch = new Sketch(pivots.size());
        for (int i = 0; i < pivots.size(); i++) {
            float dist = query.getDistance(pivots.get(i));
            if (dist < pivotDistanceList.getRanges()[i]) {
                querySketch.setBitValuePositive(i);
            }
        }
        for (Map.Entry<LocalAbstractObject, Sketch> entry : signatureFiles.entrySet()) {
            float dist = query.getDistance(entry.getKey());
            float distance = querySketch.getDistance(entry.getValue());
            ResultHolder rs = new ResultHolder(query.getLocatorURI(), entry.getKey().getLocatorURI(), dist, distance);
            ret.add(rs);
        }
        return ret;
    }

}
