package sf.deprecated.vykryvaniProstoru.ballPartitioning.sameRanges;

import java.util.Iterator;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.PivotsDistanceList;
import sf.objects.impl.Sketch;
import sf.deprecated.vykryvaniProstoru.Experiment;
import sf.deprecated.vykryvaniProstoru.ResultHolder;

/**
 *
 * @author xmic
 */
public class Experiment01 implements Experiment {

    @Override
    public SortedSet<ResultHolder> evaluateQuery(LocalAbstractObject query, Map<LocalAbstractObject, Sketch> signatureFiles, PivotsDistanceList pivotDistanceList) {
        Iterator<Map.Entry<LocalAbstractObject, Sketch>> it = signatureFiles.entrySet().iterator();
        SortedSet<ResultHolder> ret = new TreeSet();
        while (it.hasNext()) {
            Map.Entry<LocalAbstractObject, Sketch> entry = it.next();
            float dist = query.getDistance(entry.getKey());
            Float minQueryDeviation = countMinQueryPivotsDeviation3(pivotDistanceList, entry.getValue(), query);
            ResultHolder rs = new ResultHolder(query.getLocatorURI(), entry.getKey().getLocatorURI(), dist, minQueryDeviation);
            ret.add(rs);
        }
        return ret;
    }

    private float countMinQueryPivotsDeviation2(PivotsDistanceList pivotDistanceList, Sketch sf, LocalAbstractObject query) {
        float ret = Float.MAX_VALUE;
        for (int i = 0; i < sf.getSize() - 1; i++) {
            if (!sf.getBitValue(i) || query.equals(pivotDistanceList.getPivot(i))) {
                continue;
            }
            for (int j = i + 1; j < sf.getSize(); j++) {
                if (sf.getBitValue(i) && !query.equals(pivotDistanceList.getPivot(j))) {
                    float queryPivotsDeviation = countQueryPivotsDeviation2(pivotDistanceList, i, j, query);
                    if (queryPivotsDeviation < ret) {
                        ret = queryPivotsDeviation;
                    }
                }
            }
        }
        return ret;
    }

    private float countQueryPivotsDeviation2(PivotsDistanceList pivotDistanceList, int index0, int index1, LocalAbstractObject query) {
        float d0 = query.getDistance(pivotDistanceList.getPivot(index0));
        float d1 = query.getDistance(pivotDistanceList.getPivot(index1));
        float p = pivotDistanceList.getDistance(index0, index1);
        return d0 + d1 - p;
    }

    private float countMinQueryPivotsDeviation3(PivotsDistanceList pivotDistanceList, Sketch sf, LocalAbstractObject query) {
        float ret = Float.MAX_VALUE;
        for (int i = 0; i < sf.getSize() - 2; i++) {
            if (!sf.getBitValue(i) || query.equals(pivotDistanceList.getPivot(i))) {
                continue;
            }
            for (int j = i + 1; j < sf.getSize() - 1; j++) {
                if (!sf.getBitValue(j) || query.equals(pivotDistanceList.getPivot(j))) {
                    continue;
                }
                for (int k = j + 1; k < sf.getSize(); k++) {
                    if (sf.getBitValue(i) && !query.equals(pivotDistanceList.getPivot(j))) {
                        float queryPivotsDeviation = countQueryPivotsDeviation3(pivotDistanceList, i, j, k, query);
                        if (queryPivotsDeviation < ret) {
                            ret = queryPivotsDeviation;
                        }
                    }
                }
            }
        }
        return ret;
    }

    private float countQueryPivotsDeviation3(PivotsDistanceList pivotDistanceList, int index0, int index1, int index2, LocalAbstractObject query) {
        float d0 = query.getDistance(pivotDistanceList.getPivot(index0));
        float d1 = query.getDistance(pivotDistanceList.getPivot(index1));
        float d2 = query.getDistance(pivotDistanceList.getPivot(index2));
        float p01 = pivotDistanceList.getDistance(index0, index1);
        float p02 = pivotDistanceList.getDistance(index0, index2);
        float p12 = pivotDistanceList.getDistance(index1, index2);
        return 2 * (d0 + d1 + d2) - p01 - p02 - p12;
    }
}
