package sf.hyperplaneDistanceDistribution.impl;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.hyperplaneDistanceDistribution.DistanceDistibutionToDividingLineToCsv;

/**
 *
 * @author xmic
 */
public class DistanceDistributionToRandomPivotsCouplesWithGivenPartSizes extends DistanceDistibutionToDividingLineToCsv {

    public static final Float SIZE_OF_SMALLER_PART = 0.45f;

    public DistanceDistributionToRandomPivotsCouplesWithGivenPartSizes(List<LocalAbstractObject> pivots, List<LocalAbstractObject> objects) {
        super(pivots, objects);
    }

    @Override
    public void writeDistanceDistribution(OutputStream os) throws IOException {
        List<LocalAbstractObject[]> pivotPairs = new ArrayList();
        int resultSize = pivots.size() / 2;
        for (int i = 0; i < pivots.size() - 1; i++) {
            if (pivotPairs.size() == resultSize) {
                break;
            }
            for (int j = i + 1; j < pivots.size(); j++) {
                if (pivotPairs.size() == resultSize) {
                    break;
                }
                LocalAbstractObject[] pair = new LocalAbstractObject[2];
                pair[0] = pivots.get(i);
                pair[1] = pivots.get(j);
                if (dividesToPartOfSize(SIZE_OF_SMALLER_PART, pair, objects)) {
                    pivotPairs.add(pair);
                }
            }
        }
        if (pivotPairs.size() != resultSize) {
            throw new RuntimeException("Not possible to find enought pivot pair meeting condition.");
        }
        super.writeDistanceDistribution(os, pivotPairs);
    }

    public static boolean dividesToPartOfSize(float minPercentilInSmallerPart, LocalAbstractObject[] pivotPair, List<LocalAbstractObject> objects) {
        int sumOfObjects = 0;
        for (LocalAbstractObject object : objects) {
            if (pivotPair[0].getDistance(object) < pivotPair[1].getDistance(object)) {
                sumOfObjects++;
            }
        }
        float average = (float) sumOfObjects / objects.size();
        average = Math.min(average, 1 - average);
        return average >= minPercentilInSmallerPart;
    }

}
