package sf.objects.distanceFunctions.impl;

import messif.objects.DistanceFunction;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.SketchWithPivotsDistanceList;

/**
 *
 * @author xmic
 */
public class SketchHyperplaneDF implements DistanceFunction<LocalAbstractObject>{

    @Override
    public float getDistance(LocalAbstractObject o1, LocalAbstractObject o2) {
        float ret = 0;
        SketchWithPivotsDistanceList sketch = (SketchWithPivotsDistanceList) o2;
        for (int i = 0; i < sketch.getSize(); i++) {
            int piv1Idx = 2 * i;
            int piv2Idx = 2 * i + 1;
            float d1 = o1.getDistance(sketch.getPivot(piv1Idx));
            float d2 = o1.getDistance(sketch.getPivot(piv2Idx));
            float dp = SketchWithPivotsDistanceList.getPivotsDistanceList().getDistance(piv1Idx, piv2Idx);
            ret += dp / 2;
            float dc = Math.abs(d1 * d1 - d2 * d2) / (2 * dp);
            boolean bitSetValue = sketch.getBitValue(i);
            boolean sameHyperplaneSide = (bitSetValue && d1 <= d2) || (!bitSetValue && d1 >= d2);
            if (sameHyperplaneSide) {
                ret -= dc;
            } else {
                ret += dc;
            }
        }
        if(ret < 0){
            return 0;
        }
        return ret;
    }

    @Override
    public Class<? extends SketchWithPivotsDistanceList> getDistanceObjectClass() {
        return SketchWithPivotsDistanceList.class;
    }
    
}
