package sf.objects.impl;

import messif.objects.LocalAbstractObject;

/**
 *
 * @author xmic
 */
public class SketchWithPivotsDistanceList extends Sketch {

    private static PivotsDistanceList pivotsDistanceList;

    public SketchWithPivotsDistanceList(int size) {
        super(size);
    }

    public SketchWithPivotsDistanceList(String locatorURI, int size) {
        super(locatorURI, size);
    }

    public SketchWithPivotsDistanceList(Sketch sketch) {
        super(sketch.getLocatorURI(), sketch.getSize());
        bitSet.or(sketch.bitSet);
    }

    public static void createPivotsDistanceList(LocalAbstractObject[] pivots) {
        pivotsDistanceList = new PivotsDistanceList(pivots, null);
    }

    public static PivotsDistanceList getPivotsDistanceList() {
        return pivotsDistanceList;
    }

    public LocalAbstractObject getPivot(int index) {
        return pivotsDistanceList.getPivot(index);
    }
}
