/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator.impl;

import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;

/**
 *
 * @author xmic
 */
public class BalancedBitsBySomePositionsComparing extends BalancedBitsByComparing {

    private final int[] positionsToUse;

    public BalancedBitsBySomePositionsComparing(int[] positionsToUse) {
        super(positionsToUse.length);
        this.positionsToUse = positionsToUse;
    }

    @Override
    public void transformToInvertedFile(LocalAbstractObject sampleObj, List<Sketch> invertedSketches, int objectNumber) {
        float[] data = getRawVectorData(sampleObj);
        for (int i = 0; i < bitIndexes.length - 1; i = i + 2) {
            float d0 = data[positionsToUse[bitIndexes[i]]];
            float d1 = data[positionsToUse[bitIndexes[i + 1]]];
            if (d0 < d1) {
                Sketch s = invertedSketches.get(i / 2);
                synchronized (s) {
                    s.setBitValuePositive(objectNumber);
                }
            }
        }
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        float[] data = getRawVectorData(objectToTransform);
        Sketch ret = new Sketch(objectToTransform.getLocatorURI(), bitIndexes.length / 2);
        for (int i = 0; i < bitIndexes.length - 1; i = i + 2) {
            if (data[positionsToUse[bitIndexes[i]]] > data[positionsToUse[bitIndexes[i + 1]]]) {
                ret.setBitValuePositive(i / 2);
            }
        }
        return ret;
    }
    
    

}
