/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator.impl;

import java.io.Serializable;
import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;

/**
 *
 * @author xmic
 */
public class MultiVoronoiSketchTransformator extends ObjectToSketchTransformator implements Serializable {

    @SuppressWarnings("FieldNameHidesFieldInSuperclass")
    public static final long serialVersionUID = 736012248064560499l;

    private final VoronoiSketchTransformator[] partialTransformators;
    private int sketchLength;

    public MultiVoronoiSketchTransformator(String pivotFile, String objectClass, int sketchSize, String[] csvFiles, boolean uniquePivots) {
        super(pivotFile, objectClass, -1);
        partialTransformators = new VoronoiSketchTransformator[csvFiles.length];
        sketchLength = 0;
        for (int i = 0; i < csvFiles.length; i++) {
            String csvFile = csvFiles[i];
            partialTransformators[i] = new VoronoiSketchTransformator(pivots, csvFile);
            sketchLength += partialTransformators[i].getInvertedSketchesCount();
        }
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        String key = "";
        for (int i = 0; i < partialTransformators.length; i++) {
            VoronoiSketchTransformator tr = partialTransformators[i];
            key += tr.transformToWord(objectToTransform);
        }
        Sketch ret = new Sketch(objectToTransform.getLocatorURI(), sketchLength);
        char[] charArray = key.toCharArray();
        for (int i = 0; i < charArray.length; i++) {
            if (charArray[i] == '1') {
                ret.setBitValuePositive(i);
            }
        }
        return ret;
    }

    @Override
    public void transformToInvertedFile(LocalAbstractObject sampleObj, List<Sketch> invertedSketches, int objectNumber) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void removeCorrelatedBits(int[] uncorrelatedBits) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public int getInvertedSketchesCount() {
        return sketchLength;
    }

}
