/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.objects.sketchcreator.impl;

import java.util.List;
import messif.objects.LocalAbstractObject;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;
import sf.pivotAnalyzer.PivotSubsetSelector;

/**
 *
 * @author xmic
 */
public class VectorThresholdingWithConstantThreshold extends ObjectToSketchTransformator {

    private int[] bitIndexes;
    private final float threshold;
    private final Integer floatVectorLength;

    public VectorThresholdingWithConstantThreshold(int floatVectorLength, float threshold) {
        super(null);
        this.floatVectorLength = floatVectorLength;
        bitIndexes = new int[floatVectorLength];
        for (int i = 0; i < floatVectorLength - 1; i++) {
            bitIndexes[i] = i;
        }
        this.threshold = threshold;
    }

    @Override
    public Sketch transform(LocalAbstractObject objectToTransform) {
        float[] data = BalancedBitsByComparing.getRawVectorData(objectToTransform);
        if (data.length != floatVectorLength) {
            throw new IllegalArgumentException("Wrong length of raw data of transformed vector. Length needed: " + floatVectorLength + ", length provided: " + data.length);
        }
        Sketch ret = new Sketch(objectToTransform.getLocatorURI(), bitIndexes.length);
        for (int i = 0; i < bitIndexes.length; i++) {
            if (data[bitIndexes[i]] >= threshold) {
                ret.setBitValuePositive(i);
            }
        }
        return ret;
    }

    @Override
    public void transformToInvertedFile(LocalAbstractObject sampleObj, List<Sketch> invertedSketches, int objectNumber) {
        float[] data = BalancedBitsByComparing.getRawVectorData(sampleObj);
        for (int i = 0; i < bitIndexes.length; i++) {
            float d0 = data[bitIndexes[i]];
            if (d0 >= threshold) {
                Sketch s = invertedSketches.get(i);
                synchronized (s) {
                    s.setBitValuePositive(objectNumber);
                }
            }
        }
    }

    @Override
    public void removeCorrelatedBits(int[] uncorrelatedBits) {
        bitIndexes = new int[uncorrelatedBits.length];
        for (int i = 0; i < uncorrelatedBits.length; i++) {
            bitIndexes[i] = uncorrelatedBits[i];
        }
        PivotSubsetSelector.printIndexes(bitIndexes, System.out);
    }

    @Override
    public int getInvertedSketchesCount() {
        return bitIndexes.length;
    }

}
