package sf.pivotAnalyzer.threads.impl;

import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import messif.objects.LocalAbstractObject;
import sf.pivotAnalyzer.PivotSubsetSelector;
import sf.pivotAnalyzer.threads.PivotCoupleAnalyzer;

/**
 *
 * @author xmic
 */
public class HyperplaneDistancesAnalyzerGivenPairs extends PivotCoupleAnalyzer {

    public HyperplaneDistancesAnalyzerGivenPairs(LocalAbstractObject[] pivots, List<LocalAbstractObject> sampleObjects) {
        super(pivots, sampleObjects);
    }

    @Override
    public void run() {
        Iterator<LocalAbstractObject> sampleSetIterator = sampleObjects.iterator();
        float[] pivotDistances = initPivotPairsDistances();
        while (sampleSetIterator.hasNext()) {
            LocalAbstractObject sampleObject = sampleSetIterator.next();
            float[] distances = initDistances(sampleObject);
            for (int i = 0; i < pivots.length - 1; i = i + 2) {
                float distToHyperplane = getDistanceToHyperplane(distances[i], distances[i + 1], pivotDistances[i / 2]);
                int[] key = new int[]{i, i + 1};
                Float curValue = result.get(key);
                if (curValue == null) {
                    result.put(key, distToHyperplane);
                } else {
                    result.put(key, curValue + distToHyperplane);
                }
            }
        }
        Logger.getLogger(PivotSubsetSelector.class.getName()).log(Level.INFO, "Pivot selector map thread {0} finished.", new Object[]{this.getId()});
    }

    private float[] initPivotPairsDistances() {
        float[] ret = new float[pivots.length / 2];
        for (int i = 0; i < pivots.length - 1; i = i + 2) {
            ret[i / 2] = getPivotDistance(i, i + 1);
        }
        return ret;
    }

}
