/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.originalDistanceDistributionApprox;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import org.apache.commons.math4.stat.descriptive.moment.Mean;
import org.apache.commons.math4.stat.descriptive.moment.Variance;

/**
 *
 * @author xmic
 */
public class LognormalParamEstimator {

    private double[] ddX;
    private double[] ddY;

    public LognormalParamEstimator(String csvDistanceDistributionFile) {
        parse(csvDistanceDistributionFile);
    }

    public LognormalParamEstimator(double[] ddX, double[] ddY) {
        this.ddX = ddX;
        this.ddY = ddY;
    }

    private void parse(String csvDistanceDistributionFile) {
        List<String>[] parseCsv = Tools.parseCsvKeysValues(csvDistanceDistributionFile);
        List<String> keys = parseCsv[0];
        List<String> values = parseCsv[1];
        int count = keys.size();
        ddX = new double[count];
        ddY = new double[count];
        for (int i = 0; i < count; i++) {
            ddX[i] = Double.parseDouble(keys.get(i));
            ddY[i] = Double.parseDouble(values.get(i));
        }
    }

    private double evaluateDDMeanValue() {
        Mean m = new Mean();
        return m.evaluate(ddY, ddX);
    }

    private double evaluateDDVarianceValue() {
        Variance v = new Variance();
        return v.evaluate(ddY, ddX);
    }

    public double[] estimateMuSigma() {
        double m = evaluateDDMeanValue();
        double v = evaluateDDVarianceValue();
        Logger.getLogger(LognormalParamEstimator.class.getName()).log(Level.INFO, "Mean: {0}, variance: {1}, standard dev: {2}", new Object[]{m, v, Math.sqrt(v)});
        double frac = 1 + v / (m * m);
        double mu = Math.log(m / Math.sqrt(frac));
        double sigma = Math.sqrt(Math.log(frac));
        Logger.getLogger(LognormalParamEstimator.class.getName()).log(Level.INFO, "Mu: {0}, sigma: {1}", new Object[]{mu, Double.toString(sigma)});
        return new double[]{mu, sigma};
    }

    public int getValuesCount() {
        return ddX.length;
    }

    public double getX(int pos) {
        return ddX[pos];
    }

    public double getY(int pos) {
        return ddY[pos];
    }

}
