/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.recallEstimation.sketchesDistDistrForOrigDistInterval;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.logging.Level;
import java.util.logging.Logger;
import main.tools.Tools;
import messif.objects.LocalAbstractObject;
import messif.objects.impl.ObjectFloatVectorNeuralNetworkL2;
import sf.objects.impl.Sketch;
import sf.objects.sketchcreator.ObjectToSketchTransformator;

/**
 *
 * @author xmic
 */
public class TestSketchesDistDistrForOrigDistInterval {

//    public static final String className = ObjectFloatVectorNeuralNetworkL2.class.getName();
//    public static final String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
//    public static final String csvFileWithPivotsPairs = "c:\\Data\\2016\\2016_Unbalanced_sketches\\Decaf\\80_20\\pivots\\UncorrelatedPivots_256_pairs.csv";
//    public static final Integer sketchLength = 256;
//    public static final Float distCenter = 87f;
//    public static final Float tolerance = 0.5f;
//    public static final String queriesFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
//    public static final String sampleFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-100K.data.gz";
////    public static final String outputFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\" + sketchLength + "b_dist" + distCenter.toString() + "+-" + tolerance.toString() + "_100Kobjects.csv";
//    public static final String outputFile = null;
//    public static final Integer maxObjectCount = 1000;
    public static final String className = ObjectFloatVectorNeuralNetworkL2.class.getName();
    public static final String pivotFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots-random-2560.data";
//    public static final String csvFileWithPivotsPairs = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\pivots_filtered_hyperplane\\512_random\\UncorrelatedPivots_033_256_pairs.csv";
    public static final String sketchesFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\OrientedSketches\\GHP_80_20_256b.data";
    public static final Integer sketchLength = 256;
    public static final Float distCenter = 50f;
    public static final Float tolerance = 0.5f;
    public static final String queriesFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-1000-query.data";
    public static final String sampleFile = "c:\\Data\\2015_Doktorske\\Desc\\profiset\\caffe\\profi-neuralnet-100K.data.gz";
    public static final String outputFile = "c:\\Data\\2017\\2017_Separability\\Experiments\\Decaf\\" + sketchLength + "b_dist" + distCenter.toString() + "+-" + tolerance.toString() + "_500Kobjects.csv";
//    public static final String outputFile = null;
    public static final Integer maxObjectCount = 100000;
//

    public static void main(String[] args) {
//        ObjectToSketchTransformator trans = new GenHyperplane(pivotFile, className, sketchLength, csvFileWithPivotsPairs, false);
        ObjectToSketchTransformator trans = null;
        List<LocalAbstractObject> dataObjs = Tools.getObjects(className, sampleFile, -1);
        Map<String, LocalAbstractObject> sketches = Tools.getObjectsAsLocatorMap(Sketch.class.getName(), sketchesFile, -1);
        Logger.getLogger(TestSketchesDistDistrForOrigDistInterval.class.getName()).log(Level.INFO, "Starts to search object pairs.");
        int paralel = 7;
        Thread[] threads = new Thread[paralel];
        EvaluatorThread[] evaluators = new EvaluatorThread[paralel];
        int count = dataObjs.size() / paralel;
        AtomicInteger counter = new AtomicInteger(0);
        try {
            if (outputFile != null) {
                System.setOut(new PrintStream(outputFile));
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(TestSketchesDistDistrForOrigDistInterval.class.getName()).log(Level.SEVERE, null, ex);
        }
        for (int i = 0; i < paralel; i++) {
            evaluators[i] = new EvaluatorThread(trans, dataObjs, i * count, count, sketches, counter);
            threads[i] = new Thread(evaluators[i]);
            threads[i].start();
        }
        for (int i = 0; i < paralel; i++) {
            try {
                threads[i].join();
            } catch (InterruptedException ex) {
                Logger.getLogger(TestSketchesDistDistrForOrigDistInterval.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        Map<Float, Integer> ret = initMapCounter(sketchLength);
        for (int i = 0; i < paralel; i++) {
            Map<Float, Integer> partial = evaluators[i].getRet();
            Set<Float> keySet = ret.keySet();
            for (Float key : keySet) {
                Integer partialValue = partial.get(key);
                ret.put(key, ret.get(key) + partialValue);
            }
        }
        Tools.printMap(ret);
    }

    public static Sketch getSketch(Map<String, LocalAbstractObject> sketches, String locator, ObjectToSketchTransformator trans, LocalAbstractObject dataObj) {
        synchronized (sketches) {
            if (sketches.containsKey(locator)) {
                return (Sketch) sketches.get(locator);
            }
        }
        Sketch ret = trans.transform(dataObj);
        synchronized (sketches) {
            sketches.put(locator, ret);
        }
        return ret;
    }

    public static Map<Float, Integer> initMapCounter(Integer sketchLength) {
        Map<Float, Integer> ret = new TreeMap<>();
        for (Integer i = 0; i < sketchLength; i++) {
            ret.put(i.floatValue(), 0);
        }
        return ret;
    }

}
