/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separability;

import sf.separabilityAnalytique.BivariateIntegrator;

/**
 *
 * @author xmic
 */
public abstract class QualityOfSketchingTechnique {

    private final double maxDistance;

    protected QualityOfSketchingTechnique(double maxDistance) {
        this.maxDistance = maxDistance;
    }

    public double evaluateNormalized() {
        return evaluateNormalized(-1d);
    }

    public double evaluateNormalized(double maxX1) {
        SepDistsx1x2InHammSpace sepx1x2 = createInstanceSepDistsx1x2InHammSpace();
        BivariateIntegrator integrator;
        if (maxX1 >= 0) {
            integrator = new BivariateIntegrator(sepx1x2, 0, maxDistance, maxX1);
        } else {
            integrator = new BivariateIntegrator(sepx1x2, 0, maxDistance);
        }
        double quality = integrator.evaluate();
        return quality / maxDistance / maxDistance;
    }

    protected abstract SepDistsx1x2InHammSpace createInstanceSepDistsx1x2InHammSpace();

}
