/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separabilityAnalytique;

import java.io.FileNotFoundException;
import java.util.Map;
import sf.separability.QualityOfSketchingTechnique;
import java.util.SortedMap;
import sf.recallEstimation.UnivariateFunctionImpl.ProbabilitySketchBitDiffers;
import sf.recallEstimation.pxEvaluator.PxEvaluator;
import sf.recallEstimation.pxEvaluator.PxEvaluatorOnCreatedSketches;
import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class QualityOfSketchingTechniqueAnalytiqueImpl extends QualityOfSketchingTechnique {

    private final double iDim;
    private final double balanceOfBits;
    private final SortedMap<Float, Float> plotXY;

    protected QualityOfSketchingTechniqueAnalytiqueImpl(double iDim, double balanceOfBits, String csvFileWithPxValues, double maxDistance) {
        this(iDim, balanceOfBits, PxEvaluator.parse(csvFileWithPxValues), maxDistance);
    }

    protected QualityOfSketchingTechniqueAnalytiqueImpl(double iDim, double balanceOfBits, SortedMap<Float, Float> plotXY, double maxDistance) {
        super(maxDistance);
        this.iDim = iDim;
        this.balanceOfBits = balanceOfBits;
        this.plotXY = plotXY;
    }

    @Override
    protected SepDistsx1x2InHammSpace createInstanceSepDistsx1x2InHammSpace() {
        ProbabilitySketchBitDiffers px = new ProbabilitySketchBitDiffers(plotXY);
        return new SepDistsx1x2InHammSpaceAnalytiqueImpl(iDim, balanceOfBits, px);
    }

    public static void evaluateQualityOfSketches(Map<String[], Float> distsOnData, String sketchesPath, Integer sketchLength, String output, double maxDistance, double maxX1, int distInterval, int numberOfObjectsToUse, float balanceOfBits) throws FileNotFoundException {
        PxEvaluatorOnCreatedSketches pxEvaluator = new PxEvaluatorOnCreatedSketches(distsOnData, sketchesPath, sketchLength, distInterval);
        SortedMap<Float, Float> map = pxEvaluator.evaluateProbabilities();
//        Tools.printMap(map);
        float iDim = pxEvaluator.getiDim();
        System.out.println("iDim:;" + iDim);
        System.out.flush();
//        System.out.println("iDim;" + iDim);
//        PxEvaluator.printProbabilities(map, distInterval, maxDistance);

        QualityOfSketchingTechniqueAnalytiqueImpl evaluator = new QualityOfSketchingTechniqueAnalytiqueImpl(iDim, balanceOfBits, map, maxDistance);
        double quality = evaluator.evaluateNormalized(maxX1);
        System.out.print("Normalized quality of sketching technique with max dist " + maxDistance + " is:;");
        System.out.println(quality);
    }

}
