/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separabilityAnalytique;

import org.apache.commons.math4.analysis.UnivariateFunction;
import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class SepDistsx1x2InHammSpaceAnalytiqueImpl extends SepDistsx1x2InHammSpace {

    private final double iDim;
    private final double balanceOfBits;
    private final UnivariateFunction px;

    public SepDistsx1x2InHammSpaceAnalytiqueImpl(double iDim, double balanceOfBits, UnivariateFunction px) {
        this.iDim = iDim;
        this.balanceOfBits = balanceOfBits;
        this.px = px;
    }

    public SepDistsx1x2InHammSpaceAnalytiqueImpl(double iDim, UnivariateFunction px) {
        this(iDim, 0.5d, px);
    }

    @Override
    public double value(double x1, double x2) {
        double ret = 2 * Math.sqrt(iDim);
        ret = ret * Math.sqrt(1 / (2 * balanceOfBits * (1 - balanceOfBits)) - 1);
        ret = ret * f(px.value(x1), px.value(x2));
        return ret;
    }

    private double f(double px1, double px2) {
        double numerator = px2 - px1;
        double denominator = px1 * (1 - px1) + px2 * (1 - px2);
        if (denominator == 0) {
            return 0;
        }
        return numerator / Math.sqrt(denominator);
    }

}
