/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sf.separabilityMeasured;

import java.awt.geom.Point2D;
import java.util.List;
import main.tools.Tools;
import sf.separability.SepDistsx1x2InHammSpace;

/**
 *
 * @author xmic
 */
public class SepDistsx1x2InHammSpaceMeasuredImpl extends SepDistsx1x2InHammSpace {

    private final List<Point2D.Float> meansOfPxbForX;
    private final List<Point2D.Float> variancesOfPxbForX;
    private final List<Point2D.Float> sketchesPairsCounts;
    private final int hamDistsCountsForWeights;

    public SepDistsx1x2InHammSpaceMeasuredImpl(List<Point2D.Float> meansOfPxbForX, List<Point2D.Float> variancesOfPxbForX) {
        this(meansOfPxbForX, variancesOfPxbForX, null);
    }

    SepDistsx1x2InHammSpaceMeasuredImpl(List<Point2D.Float> meansOfPxbForX, List<Point2D.Float> variancesOfPxbForX, List<Point2D.Float> sketchesPairsCounts) {
        this.meansOfPxbForX = meansOfPxbForX;
        this.variancesOfPxbForX = variancesOfPxbForX;
        this.sketchesPairsCounts = sketchesPairsCounts;
        if (sketchesPairsCounts != null) {
            hamDistsCountsForWeights = (int) sketchesPairsCounts.get(0).y;
        } else {
            hamDistsCountsForWeights = -1;
        }
    }

    @Override
    public double value(double x1, double x2) {
        float m1 = Tools.interpolatePoints(meansOfPxbForX, (float) x1);
        float m2 = Tools.interpolatePoints(meansOfPxbForX, (float) x2);
        float s1 = Tools.interpolatePoints(variancesOfPxbForX, (float) x1);
        float s2 = Tools.interpolatePoints(variancesOfPxbForX, (float) x2);
        double ret = (m2 - m1) / (Math.sqrt((s1 + s2) / 2f));
//        if (sketchesPairsCounts == null || ret == 0) {
            return ret;
//        }
//        float weightX1 = Tools.interpolatePoints(sketchesPairsCounts, (float) x1) / hamDistsCountsForWeights;
//        float weightX2 = Tools.interpolatePoints(sketchesPairsCounts, (float) x2) / hamDistsCountsForWeights;
//        return 100000 * ret * weightX1 * weightX2;
    }

}
